package physapps.linearoscillations;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class DrivenChain2 extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new DrivenChain2(), 580, 590);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    linearChainOscillator1 = new physbeans.phys.LinearChainOscillator();
    springChainView1 = new physbeans.views.SpringChainView();
    harmonicFunction1 = new physbeans.func.HarmonicFunction();
    combineScalarsFunction1 = new physbeans.func.CombineScalarsFunction();
    multiplexer1 = new physbeans.func.Multiplexer();
    selectorC = new physbeans.func.Selector();
    selectorB = new physbeans.func.Selector();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    vectorSliderM = new physbeans.inout.VectorSlider();
    vectorSliderC = new physbeans.inout.VectorSlider();
    vectorSliderB = new physbeans.inout.VectorSlider();
    textSliderF = new physbeans.inout.TextSlider();
    textSliderOm = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();

    linearChainOscillator1.setAbsoluteTolerance(1.0E-8);
    linearChainOscillator1.setDamperCoefficients(DVector.valueOf("[0.0,0.0,0.0]"));
    linearChainOscillator1.setExternalForceFunction(combineScalarsFunction1);
    linearChainOscillator1.setMasses(DVector.valueOf("[0.0,0.0]"));
    linearChainOscillator1.setSpringStiffnesses(DVector.valueOf("[0.0,0.0,0.0]"));
    linearChainOscillator1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        linearChainOscillator1ValueChanged1(evt);
        linearChainOscillator1ValueChanged2(evt);
      }
    });

    springChainView1.setXScale(0.15);
    springChainView1.setHideHugeSprings(true);
    springChainView1.setInitialDisplacements(DVector.valueOf("[0.0,0.0]"));
    springChainView1.setMassScale(0.8);
    springChainView1.setShowArrows(true);
    springChainView1.setSpringScale(0.8);
    springChainView1.setSystem(linearChainOscillator1);
    springChainView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        springChainView1SourceChanged(evt);
      }
    });

    harmonicFunction1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        harmonicFunction1SourceChanged(evt);
      }
    });

    combineScalarsFunction1.setSize(2);
    combineScalarsFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        combineScalarsFunction1ValueChanged(evt);
      }
    });

    multiplexer1.setInputLength(3);
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });

    selectorC.setIndex(new int[]{0,1});
    selectorC.setOutputLength(3);
    selectorC.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        selectorCValueChanged(evt);
      }
    });

    selectorB.setIndex(new int[]{0,1});
    selectorB.setOutputLength(3);
    selectorB.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        selectorBValueChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    objectPanel.setLayout(new java.awt.BorderLayout());

    layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(4.0);
    layeredScreen1.setMinX(0.0);
    layeredScreen1.setOpaque(true);
    objectPanel.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel);

    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    outputPanel.setPreferredSize(new java.awt.Dimension(300, 142));
    outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.LINE_AXIS));

    oscilloscope1.setNLines(3);
    oscilloscope1.setLineActive(new boolean[]{true,true,false});
    oscilloscope1.setMaxY(1.5);
    oscilloscope1.setMinY(-1.5);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.linearoscillations.DrivenChain2", currentLocale); // NOI18N
    oscilloscope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    oscilloscope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    outputPanel.add(oscilloscope1);

    jPanel2.add(outputPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(20L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
        timer1NextStep1(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
        timer1Restart2(evt);
      }
    });
    inputPanel.add(timer1);

    vectorSliderM.setCount(2);
    vectorSliderM.setDescription("m =");
    vectorSliderM.setInitialValues(DVector.valueOf("[5.0,0.5]"));
    vectorSliderM.setLogarithmic(true);
    vectorSliderM.setMaximum(100.0);
    vectorSliderM.setMinimum(0.0010);
    vectorSliderM.setUnit("kg");
    vectorSliderM.setVertical(false);
    vectorSliderM.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderMPropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderM);

    vectorSliderC.setCount(2);
    vectorSliderC.setDescription("c =");
    vectorSliderC.setInitialValues(DVector.valueOf("[10.0,1.0]"));
    vectorSliderC.setLogarithmic(true);
    vectorSliderC.setMaximum(100.0);
    vectorSliderC.setMinimum(0.01);
    vectorSliderC.setUnit("N/m");
    vectorSliderC.setVertical(false);
    vectorSliderC.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderCPropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderC);

    vectorSliderB.setCount(2);
    vectorSliderB.setDescription("b =");
    vectorSliderB.setInitialValues(DVector.valueOf("[0.1,0.1]"));
    vectorSliderB.setLogarithmic(true);
    vectorSliderB.setMaximum(100.0);
    vectorSliderB.setMinimum(0.0010);
    vectorSliderB.setUnit("Ns/m");
    vectorSliderB.setVertical(false);
    vectorSliderB.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderBPropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderB);

    textSliderF.setDescription("F =");
    textSliderF.setModel(new BoundedRealModel(0.0,1.0,2.0));
    textSliderF.setUnit("N");
    textSliderF.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderFPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderF);

    textSliderOm.setDescription("\u03a9 =");
    textSliderOm.setModel(new BoundedRealModel(0.0,1.4142,3.0));
    textSliderOm.setUnit("1/s");
    textSliderOm.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderOmPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderOm);

    switchBox1.setBoxLabel(new String[] {"x1", "x2", "F"});
    switchBox1.setSelected(new boolean[]{true,true,false});
    switchBox1.setTitle(bundle.getString("s1")); // NOI18N
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    inputPanel.add(switchBox1);

    jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void selectorBValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selectorBValueChanged
    linearChainOscillator1.setDamperCoefficients(selectorB.getOutputVector());
  }//GEN-LAST:event_selectorBValueChanged

  private void vectorSliderBPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderBPropertyChange
    selectorB.setInputVector(vectorSliderB.getValue());
  }//GEN-LAST:event_vectorSliderBPropertyChange

  private void selectorCValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selectorCValueChanged
    linearChainOscillator1.setSpringStiffnesses(selectorC.getOutputVector());
  }//GEN-LAST:event_selectorCValueChanged

  private void vectorSliderCPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderCPropertyChange
    selectorC.setInputVector(vectorSliderC.getValue());
  }//GEN-LAST:event_vectorSliderCPropertyChange

  private void textSliderFPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderFPropertyChange
    harmonicFunction1.setAmplitude(textSliderF.getValue());
  }//GEN-LAST:event_textSliderFPropertyChange
  
  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    oscilloscope1.setInputVector(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged
    
  private void linearChainOscillator1ValueChanged2(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_linearChainOscillator1ValueChanged2
    DVector v = linearChainOscillator1.getOutputVector();
    multiplexer1.setInputValues(0, v.get(0));
    multiplexer1.setInputValues(1, v.get(1));
  }//GEN-LAST:event_linearChainOscillator1ValueChanged2
  
  private void linearChainOscillator1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_linearChainOscillator1ValueChanged1
    springChainView1.setDisplacements(linearChainOscillator1.getDisplacements());
  }//GEN-LAST:event_linearChainOscillator1ValueChanged1
    
  private void timer1NextStep1(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep1
    combineScalarsFunction1.setInputValue(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep1
    
  private void textSliderOmPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderOmPropertyChange
    harmonicFunction1.setOmega(textSliderOm.getValue());
  }//GEN-LAST:event_textSliderOmPropertyChange
    
  private void harmonicFunction1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_harmonicFunction1SourceChanged
    combineScalarsFunction1.addFunction(0, harmonicFunction1);
  }//GEN-LAST:event_harmonicFunction1SourceChanged
  
  private void combineScalarsFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_combineScalarsFunction1ValueChanged
    DVector vec = combineScalarsFunction1.getOutputVector();
    springChainView1.setForces(vec);
    multiplexer1.singleInputValue(2, vec.get(0));
  }//GEN-LAST:event_combineScalarsFunction1ValueChanged
  
  private void vectorSliderMPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderMPropertyChange
    linearChainOscillator1.setMasses(vectorSliderM.getValue());
  }//GEN-LAST:event_vectorSliderMPropertyChange
    
  private void timer1Restart2(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart2
    springChainView1.restart();
  }//GEN-LAST:event_timer1Restart2
  
  private void springChainView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_springChainView1SourceChanged
    layeredScreen1.addView(springChainView1);
  }//GEN-LAST:event_springChainView1SourceChanged
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    linearChainOscillator1.restart();
  }//GEN-LAST:event_timer1Restart1
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    linearChainOscillator1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.CombineScalarsFunction combineScalarsFunction1;
  protected physbeans.func.HarmonicFunction harmonicFunction1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.LinearChainOscillator linearChainOscillator1;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.func.Selector selectorB;
  protected physbeans.func.Selector selectorC;
  protected physbeans.views.SpringChainView springChainView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSliderF;
  protected physbeans.inout.TextSlider textSliderOm;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.VectorSlider vectorSliderB;
  protected physbeans.inout.VectorSlider vectorSliderC;
  protected physbeans.inout.VectorSlider vectorSliderM;
  // End of variables declaration//GEN-END:variables
  
}
