package physapps.linearoscillations;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class LongitudinalChain extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new LongitudinalChain(), 750, 520);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    linearChainOscillator1 = new physbeans.phys.LinearChainOscillator();
    springChainView1 = new physbeans.views.SpringChainView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    vectorSlider1 = new physbeans.inout.VectorSlider();
    textSlider1 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();
    
    linearChainOscillator1.setDamperCoefficients(DVector.valueOf("[0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0]"));
    linearChainOscillator1.setMasses(DVector.valueOf("[1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0]"));
    linearChainOscillator1.setSpringStiffnesses(DVector.valueOf("[1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0]"));
    linearChainOscillator1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        linearChainOscillator1ValueChanged1(evt);
        linearChainOscillator1ValueChanged(evt);
      }
    });
    
    springChainView1.setInitialDisplacements(DVector.valueOf("[0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0]"));
    springChainView1.setInitialForces(DVector.valueOf("[0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0]"));
    springChainView1.setSquare(false);
    springChainView1.setSystem(linearChainOscillator1);
    springChainView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        springChainView1SourceChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel2.setFont(standardFont);
    objectPanel.setLayout(new java.awt.BorderLayout());
    
    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(11.0);
    layeredScreen1.setMinX(0.0);
    layeredScreen1.setOpaque(true);
    objectPanel.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel);
    
    outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.X_AXIS));
    
    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    outputPanel.setPreferredSize(new java.awt.Dimension(300, 142));
    oscilloscope1.setNLines(10);
    oscilloscope1.setLineActive(new boolean[]{true,true,true,false,false,false,false,false,false,true});
    oscilloscope1.setLineColor(new Color[]{
      new Color(0, 255, 0),
      new Color(28, 255, 28),
      new Color(56, 255, 56),
      new Color(84, 255, 84),
      new Color(112, 255, 112),
      new Color(140, 255, 140),
      new Color(168, 255, 168),
      new Color(196, 255, 196),
      new Color(224, 255, 224),
      new Color(255, 255, 255)});
    oscilloscope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.LongitudinalChain", currentLocale).getString("osciPosition"));
    oscilloscope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.LongitudinalChain", currentLocale).getString("osciScale"));
    outputPanel.add(oscilloscope1);
    
    jPanel2.add(outputPanel);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));
    
    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    timer1.setDelay(20L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.linearoscillations.LongitudinalChain", currentLocale).getString("timerLabel"));
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
        timer1Restart2(evt);
      }
    });
    
    inputPanel.add(timer1);
    
    vectorSlider1.setCount(10);
    vectorSlider1.setDescription(" x0 =");
    vectorSlider1.setInitialValues(DVector.valueOf("[1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0]"));
    vectorSlider1.setMinimum(-1.0);
    vectorSlider1.setUnit("m");
    vectorSlider1.setVertical(false);
    vectorSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSlider1PropertyChange(evt);
        vectorSlider1PropertyChange1(evt);
      }
    });
    
    inputPanel.add(vectorSlider1);
    
    textSlider1.setDescription("c =");
    textSlider1.setLogarithmic(true);
    textSlider1.setModel(new BoundedRealModel(0.01,1.0,100.0));
    textSlider1.setUnit("N/m");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel.add(textSlider1);
    
    switchBox1.setBoxLabel(new String[] {"x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10"});
    switchBox1.setSelected(new boolean[]{true,true,true,false,false,false,false,false,false,true});
    switchBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.linearoscillations.LongitudinalChain", currentLocale).getString("s1"));
    switchBox1.setWithTwoColumns(true);
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    
    inputPanel.add(switchBox1);
    
    jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents

  private void linearChainOscillator1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_linearChainOscillator1ValueChanged
    oscilloscope1.setInputVector(linearChainOscillator1.getDisplacements());
  }//GEN-LAST:event_linearChainOscillator1ValueChanged

  private void linearChainOscillator1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_linearChainOscillator1ValueChanged1
    springChainView1.setDisplacements(linearChainOscillator1.getDisplacements());
  }//GEN-LAST:event_linearChainOscillator1ValueChanged1

  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    double val = textSlider1.getValue();
    DVector cNew = DVector.createFilledDVector(11, val);
    linearChainOscillator1.setSpringStiffnesses(cNew);
  }//GEN-LAST:event_textSlider1PropertyChange

  private void vectorSlider1PropertyChange1(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSlider1PropertyChange1
    springChainView1.setInitialDisplacements(vectorSlider1.getValue());
  }//GEN-LAST:event_vectorSlider1PropertyChange1

  private void vectorSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSlider1PropertyChange
    linearChainOscillator1.setX0(vectorSlider1.getValue());
  }//GEN-LAST:event_vectorSlider1PropertyChange

  private void timer1Restart2(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart2
    springChainView1.restart();
  }//GEN-LAST:event_timer1Restart2

  private void springChainView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_springChainView1SourceChanged
    layeredScreen1.addView(springChainView1);
  }//GEN-LAST:event_springChainView1SourceChanged

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged

  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    linearChainOscillator1.restart();
  }//GEN-LAST:event_timer1Restart1

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    linearChainOscillator1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.LinearChainOscillator linearChainOscillator1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.views.SpringChainView springChainView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.VectorSlider vectorSlider1;
// End of variables declaration//GEN-END:variables
  
}
