package physapps.linearoscillations;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class RectDrivenSpring extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new RectDrivenSpring(), 540, 525);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    drivenSpring1 = new physbeans.phys.DrivenSpring();
    squareFunction1 = new physbeans.func.SquareFunction();
    multiplexer1 = new physbeans.func.Multiplexer();
    selector1 = new physbeans.func.Selector();
    springView1 = new physbeans.views.SpringView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();
    
    drivenSpring1.setB(1.0);
    drivenSpring1.setExternalForceFunction(squareFunction1);
    drivenSpring1.setX0(0.0);
    drivenSpring1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        drivenSpring1ValueChanged(evt);
      }
    });
    
    squareFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        squareFunction1ValueChanged(evt);
        squareFunction1ValueChanged1(evt);
      }
    });
    
    multiplexer1.setInputLength(3);
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });
    
    selector1.setIndex(new int[]{0,2});
    selector1.setInputLength(3);
    selector1.setOutputLength(2);
    selector1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        selector1ValueChanged(evt);
      }
    });
    
    springView1.setArrowScale(0.45);
    springView1.setEndLineLength(0.1);
    springView1.setFixPosition(-1.1);
    springView1.setInitialValues(DVector.valueOf("[0.0,0.8]"));
    springView1.setMassHeight(0.15);
    springView1.setMassWidth(0.15);
    springView1.setShowArrow(true);
    springView1.setSpringWidth(0.3);
    springView1.setStartLineLength(0.03);
    springView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        springView1SourceChanged(evt);
        springView1SourceChanged1(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel2.setFont(standardFont);
    layeredScreen1.setBordered(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(1.1);
    layeredScreen1.setMinX(-1.1);
    layeredScreen1.setBackground(java.awt.Color.white);
    layeredScreen1.setOpaque(true);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel1);
    
    oscilloscope1.setNLines(3);
    oscilloscope1.setLineActive(new boolean[]{true,false,true});
    oscilloscope1.setMaxY(3.2);
    oscilloscope1.setMinY(-3.2);
    oscilloscope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.RectDrivenSpring", currentLocale).getString("osciPosition"));
    oscilloscope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.RectDrivenSpring", currentLocale).getString("osciScale"));
    outputPanel1.add(oscilloscope1);
    
    jPanel2.add(outputPanel1);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    timer1.setDelay(30L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.linearoscillations.RectDrivenSpring", currentLocale).getString("timerLabel"));
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    
    inputPanel1.add(timer1);
    
    textSlider1.setDescription("b/m =");
    textSlider1.setModel(new BoundedRealModel(0.0,1.0,2.0));
    textSlider1.setUnit("1/s");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider2.setDescription("c/m =");
    textSlider2.setLogarithmic(true);
    textSlider2.setModel(new BoundedRealModel(0.1,1.0,10.0));
    textSlider2.setUnit("1/s\u00b2");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider3.setDescription("B/m =");
    textSlider3.setModel(new BoundedRealModel(0.0,0.8,1.6));
    textSlider3.setUnit("m/s\u00b2");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    textSlider4.setDescription("\u03c9_ext =");
    textSlider4.setModel(new BoundedRealModel(0.0,1.0,2.0));
    textSlider4.setUnit("1/s");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider4);
    
    textSlider5.setDescription("p =");
    textSlider5.setModel(new BoundedRealModel(0.0010,0.5,0.999));
    textSlider5.setUnit("");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider5);
    
    switchBox1.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.RectDrivenSpring", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.RectDrivenSpring", currentLocale).getString("s2"),
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.RectDrivenSpring", currentLocale).getString("s3")
    });
    switchBox1.setSelected(new boolean[]{true,false,true});
    switchBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.linearoscillations.RectDrivenSpring", currentLocale).getString("s4"));
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    
    inputPanel1.add(switchBox1);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents

  private void springView1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_springView1SourceChanged1
    layeredScreen1.addView(springView1);
  }//GEN-LAST:event_springView1SourceChanged1

  private void springView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_springView1SourceChanged
    layeredScreen1.addView(springView1);
  }//GEN-LAST:event_springView1SourceChanged
  
  private void squareFunction1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_squareFunction1ValueChanged1
    multiplexer1.setInputValues(2, squareFunction1.getOutputValue());
  }//GEN-LAST:event_squareFunction1ValueChanged1
  
  private void drivenSpring1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_drivenSpring1ValueChanged
    multiplexer1.setInputValues(0, drivenSpring1.getOutputVector().get(0));
    multiplexer1.setInputValues(1, drivenSpring1.getOutputVector().get(1));
  }//GEN-LAST:event_drivenSpring1ValueChanged
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    drivenSpring1.setTime(timer1.getTime());
    squareFunction1.setInputValue(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    squareFunction1.setPulseWidth(textSlider5.getValue());
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void squareFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_squareFunction1ValueChanged
    multiplexer1.setInputValues(2, squareFunction1.getOutputValue());
  }//GEN-LAST:event_squareFunction1ValueChanged
  
  private void selector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selector1ValueChanged
    springView1.setModel(selector1.getOutputVector());
  }//GEN-LAST:event_selector1ValueChanged
  
  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    DVector val = multiplexer1.getOutputVector();
    oscilloscope1.setInputVector(val);
    selector1.setInputVector(val);
  }//GEN-LAST:event_multiplexer1ValueChanged
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    double omega = textSlider4.getValue();
    squareFunction1.setPeriod(2*Math.PI/omega);
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    double val = textSlider3.getValue();
    squareFunction1.setAmplitude(val);
    springView1.setInitialValue(1, val);
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    drivenSpring1.setC(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    drivenSpring1.setB(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    drivenSpring1.restart();
    springView1.restart();
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.phys.DrivenSpring drivenSpring1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.func.Selector selector1;
  protected physbeans.views.SpringView springView1;
  protected physbeans.func.SquareFunction squareFunction1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.inout.Timer timer1;
// End of variables declaration//GEN-END:variables
  
}
