package physapps.linearoscillations;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;

/**
 * base class of all simple computation applets <br>
 * contains an input and an output panel<br>
 *
 */
public class SpringChair extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new SpringChair(), 330, 190);
  }
  
  /** Creates new form PhysicsApplet */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    checkedFunction1 = new physbeans.func.CheckedFunction();
    jPanel1 = new javax.swing.JPanel();
    inputPanel1 = new physbeans.inout.InputPanel();
    numericTextLine1 = new physbeans.inout.NumericTextLine();
    numericTextLine2 = new physbeans.inout.NumericTextLine();
    numericTextLine3 = new physbeans.inout.NumericTextLine();
    numericTextLine4 = new physbeans.inout.NumericTextLine();
    outputPanel1 = new physbeans.inout.OutputPanel();
    numericTextLine5 = new physbeans.inout.NumericTextLine();
    numericTextLine6 = new physbeans.inout.NumericTextLine();
    
    checkedFunction1.setCheckString("(c>0) & (b>0) & (tE>0) & (tE<tF) & (tF>0)");
    checkedFunction1.setFunction(new String[] {"k1E*(1 + sqrt(1 - k2E*k2E)); k1E: c*tE*tE/(8*pi*pi); k2E: 2*pi*b/(c*tE)", "mF - mE; mE: k1E*(1 + sqrt(1 - k2E*k2E)); k1E: c*tE*tE/(8*pi*pi); k2E: 2*pi*b/(c*tE); mF: k1F*(1 + sqrt(1 - k2F*k2F)); k1F: c*tF*tF/(8*pi*pi); k2F: 2*pi*b/(c*tF)"});
    checkedFunction1.setVariableName(new String[] {"c", "b", "tE", "tF"});
    checkedFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        checkedFunction1ValueChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel1.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED), new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    numericTextLine1.setDescription(java.util.ResourceBundle.getBundle("physapps.linearoscillations.SpringChair", currentLocale).getString("s2"));
    numericTextLine1.setOffset(35);
    numericTextLine1.setPrecision(5);
    numericTextLine1.setTitle(java.util.ResourceBundle.getBundle("physapps.linearoscillations.SpringChair", currentLocale).getString("s1"));
    numericTextLine1.setUnit("N/m");
    numericTextLine1.setValue(600.0);
    numericTextLine1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        numericTextLine1PropertyChange(evt);
      }
    });
    numericTextLine1.addVetoableChangeListener(new java.beans.VetoableChangeListener() {
      public void vetoableChange(java.beans.PropertyChangeEvent evt)throws java.beans.PropertyVetoException {
        numericTextLine1VetoableChange(evt);
      }
    });
    
    inputPanel1.add(numericTextLine1);
    
    numericTextLine2.setDescription(java.util.ResourceBundle.getBundle("physapps.linearoscillations.SpringChair", currentLocale).getString("s5"));
    numericTextLine2.setOffset(35);
    numericTextLine2.setPrecision(5);
    numericTextLine2.setTitle(java.util.ResourceBundle.getBundle("physapps.linearoscillations.SpringChair", currentLocale).getString("s4"));
    numericTextLine2.setUnit("kg/s");
    numericTextLine2.setValue(10.0);
    numericTextLine2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        numericTextLine2PropertyChange(evt);
      }
    });
    numericTextLine2.addVetoableChangeListener(new java.beans.VetoableChangeListener() {
      public void vetoableChange(java.beans.PropertyChangeEvent evt)throws java.beans.PropertyVetoException {
        numericTextLine2VetoableChange(evt);
      }
    });
    
    inputPanel1.add(numericTextLine2);
    
    numericTextLine3.setDescription(java.util.ResourceBundle.getBundle("physapps.linearoscillations.SpringChair", currentLocale).getString("s8"));
    numericTextLine3.setOffset(35);
    numericTextLine3.setPrecision(5);
    numericTextLine3.setTitle(java.util.ResourceBundle.getBundle("physapps.linearoscillations.SpringChair", currentLocale).getString("s7"));
    numericTextLine3.setUnit("s");
    numericTextLine3.setValue(0.9);
    numericTextLine3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        numericTextLine3PropertyChange(evt);
      }
    });
    numericTextLine3.addVetoableChangeListener(new java.beans.VetoableChangeListener() {
      public void vetoableChange(java.beans.PropertyChangeEvent evt)throws java.beans.PropertyVetoException {
        numericTextLine3VetoableChange(evt);
      }
    });
    
    inputPanel1.add(numericTextLine3);
    
    numericTextLine4.setDescription(java.util.ResourceBundle.getBundle("physapps.linearoscillations.SpringChair", currentLocale).getString("s11"));
    numericTextLine4.setOffset(35);
    numericTextLine4.setPrecision(5);
    numericTextLine4.setTitle(java.util.ResourceBundle.getBundle("physapps.linearoscillations.SpringChair", currentLocale).getString("s10"));
    numericTextLine4.setUnit("s");
    numericTextLine4.setValue(2.4);
    numericTextLine4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        numericTextLine4PropertyChange(evt);
      }
    });
    numericTextLine4.addVetoableChangeListener(new java.beans.VetoableChangeListener() {
      public void vetoableChange(java.beans.PropertyChangeEvent evt)throws java.beans.PropertyVetoException {
        numericTextLine4VetoableChange(evt);
      }
    });
    
    inputPanel1.add(numericTextLine4);
    
    jPanel1.add(inputPanel1);
    
    outputPanel1.setLayout(new javax.swing.BoxLayout(outputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    numericTextLine5.setDescription(java.util.ResourceBundle.getBundle("physapps.linearoscillations.SpringChair", currentLocale).getString("s14"));
    numericTextLine5.setEditable(false);
    numericTextLine5.setOffset(35);
    numericTextLine5.setPrecision(5);
    numericTextLine5.setTitle(java.util.ResourceBundle.getBundle("physapps.linearoscillations.SpringChair", currentLocale).getString("s13"));
    numericTextLine5.setUnit("kg");
    outputPanel1.add(numericTextLine5);
    
    numericTextLine6.setDescription(java.util.ResourceBundle.getBundle("physapps.linearoscillations.SpringChair", currentLocale).getString("s17"));
    numericTextLine6.setEditable(false);
    numericTextLine6.setOffset(35);
    numericTextLine6.setPrecision(5);
    numericTextLine6.setTitle(java.util.ResourceBundle.getBundle("physapps.linearoscillations.SpringChair", currentLocale).getString("s16"));
    numericTextLine6.setUnit("kg");
    outputPanel1.add(numericTextLine6);
    
    jPanel1.add(outputPanel1);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }
// </editor-fold>//GEN-END:initComponents
  
  private void checkedFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_checkedFunction1ValueChanged
    numericTextLine5.setValue(checkedFunction1.getOutputValues(0));
    numericTextLine6.setValue(checkedFunction1.getOutputValues(1));
  }//GEN-LAST:event_checkedFunction1ValueChanged
  
  private void numericTextLine1VetoableChange(java.beans.PropertyChangeEvent evt)throws java.beans.PropertyVetoException {//GEN-FIRST:event_numericTextLine1VetoableChange
    checkedFunction1.checkValue(0, evt);
  }//GEN-LAST:event_numericTextLine1VetoableChange
  
  private void numericTextLine1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_numericTextLine1PropertyChange
    checkedFunction1.singleInputValue(0, numericTextLine1.getValue());
  }//GEN-LAST:event_numericTextLine1PropertyChange
  
  private void numericTextLine4VetoableChange(java.beans.PropertyChangeEvent evt) throws java.beans.PropertyVetoException {//GEN-FIRST:event_numericTextLine4VetoableChange
    checkedFunction1.checkValue(3, evt);
  }//GEN-LAST:event_numericTextLine4VetoableChange
  
  private void numericTextLine3VetoableChange(java.beans.PropertyChangeEvent evt) throws java.beans.PropertyVetoException {//GEN-FIRST:event_numericTextLine3VetoableChange
    checkedFunction1.checkValue(2, evt);
  }//GEN-LAST:event_numericTextLine3VetoableChange
  
  private void numericTextLine2VetoableChange(java.beans.PropertyChangeEvent evt) throws java.beans.PropertyVetoException {//GEN-FIRST:event_numericTextLine2VetoableChange
    checkedFunction1.checkValue(1, evt);
  }//GEN-LAST:event_numericTextLine2VetoableChange
  
  private void numericTextLine4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_numericTextLine4PropertyChange
    checkedFunction1.singleInputValue(3, numericTextLine4.getValue());
  }//GEN-LAST:event_numericTextLine4PropertyChange
  
  private void numericTextLine3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_numericTextLine3PropertyChange
    checkedFunction1.singleInputValue(2, numericTextLine3.getValue());
  }//GEN-LAST:event_numericTextLine3PropertyChange
  
  private void numericTextLine2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_numericTextLine2PropertyChange
    checkedFunction1.singleInputValue(1, numericTextLine2.getValue());
  }//GEN-LAST:event_numericTextLine2PropertyChange
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.CheckedFunction checkedFunction1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.NumericTextLine numericTextLine1;
  protected physbeans.inout.NumericTextLine numericTextLine2;
  protected physbeans.inout.NumericTextLine numericTextLine3;
  protected physbeans.inout.NumericTextLine numericTextLine4;
  protected physbeans.inout.NumericTextLine numericTextLine5;
  protected physbeans.inout.NumericTextLine numericTextLine6;
  protected physbeans.inout.OutputPanel outputPanel1;
// End of variables declaration//GEN-END:variables
  
}
