package physapps.mathematics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class MonteCarloPi extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new MonteCarloPi(), 330, 400);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    uniformRandomVector1 = new physbeans.func.UniformRandomVector();
    uniformRandomVector2 = new physbeans.func.UniformRandomVector();
    parsedVectorFunction1 = new physbeans.func.ParsedVectorFunction();
    sumFunction1 = new physbeans.func.SumFunction();
    arithmeticFunction1 = new physbeans.func.ArithmeticFunction();
    pointView1 = new physbeans.views.PointView();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    simpleFigureView2 = new physbeans.views.SimpleFigureView();
    jPanel1 = new javax.swing.JPanel();
    inputPanel1 = new physbeans.inout.InputPanel();
    integerTextSlider1 = new physbeans.inout.IntegerTextSlider();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    numericTextField1 = new physbeans.inout.NumericTextField();
    numericTextField2 = new physbeans.inout.NumericTextField();

    uniformRandomVector1.setRandomize(true);
    uniformRandomVector1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        uniformRandomVector1ValueChanged(evt);
      }
    });

    uniformRandomVector2.setRandomize(true);
    uniformRandomVector2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        uniformRandomVector2ValueChanged(evt);
      }
    });

    parsedVectorFunction1.setAutoTriggered(false);
    parsedVectorFunction1.setFunction(new String[] {"if(v1*v1+v2*v2 < 1.0, 1.0, 0.0)"});
    parsedVectorFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedVectorFunction1ValueChanged(evt);
      }
    });

    sumFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        sumFunction1ValueChanged(evt);
      }
    });

    arithmeticFunction1.setFirstOp(3);
    arithmeticFunction1.setSecondOp(2);
    arithmeticFunction1.setThirdArg(4.0);
    arithmeticFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction1ValueChanged(evt);
      }
    });

    pointView1.setDepth(60);
    pointView1.setPaintCross(false);
    pointView1.setPointRadius(0.0055);
    pointView1.setUseTwoVectors(true);
    pointView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        pointView1SourceChanged(evt);
      }
    });

    simpleFigureView1.setFigureType(8);
    simpleFigureView1.setP1(DVector.valueOf("[-1.0,-1.0]"));
    simpleFigureView1.setP2(DVector.valueOf("[1.0,1.0]"));

    simpleFigureView2.setDepth(40);
    simpleFigureView2.setFigureType(5);
    simpleFigureView2.setP2(DVector.valueOf("[1.0,1.0]"));

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setPreferredSize(new java.awt.Dimension(330, 390));
    jPanel1.setLayout(new java.awt.BorderLayout());

    inputPanel1.setAlignmentX(0.5F);

    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.mathematics.MonteCarloPi", currentLocale); // NOI18N
    integerTextSlider1.setDescription(bundle.getString("s1")); // NOI18N
    integerTextSlider1.setLogarithmic(true);
    integerTextSlider1.setModel(new BoundedRealModel(1.0,100.0,100000.0));
    integerTextSlider1.setUnit("");
    integerTextSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        integerTextSlider1PropertyChange(evt);
      }
    });
    inputPanel1.add(integerTextSlider1);

    jPanel1.add(inputPanel1, java.awt.BorderLayout.NORTH);

    objectPanel1.setBordered(true);
    objectPanel1.setPreferredSize(new java.awt.Dimension(200, 280));

    layeredScreen1.setMaxX(1.02);
    layeredScreen1.setMaxY(1.02);
    layeredScreen1.setMinX(-0.02);
    layeredScreen1.setMinY(-0.02);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel1.add(objectPanel1, java.awt.BorderLayout.CENTER);

    outputPanel1.setBordered(true);

    numericTextField1.setDescription(bundle.getString("s3")); // NOI18N
    numericTextField1.setEditable(false);
    numericTextField1.setPrecision(6);
    numericTextField1.setUnit("");
    outputPanel1.add(numericTextField1);

    numericTextField2.setDescription(bundle.getString("s5")); // NOI18N
    numericTextField2.setEditable(false);
    numericTextField2.setPrecision(6);
    numericTextField2.setUnit("");
    outputPanel1.add(numericTextField2);

    jPanel1.add(outputPanel1, java.awt.BorderLayout.SOUTH);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents
  
  private void pointView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pointView1SourceChanged
    layeredScreen1.addView(pointView1);
    layeredScreen1.addView(simpleFigureView1);
    layeredScreen1.addView(simpleFigureView2);
  }//GEN-LAST:event_pointView1SourceChanged
  
  private void parsedVectorFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedVectorFunction1ValueChanged
    sumFunction1.setInputVector(parsedVectorFunction1.getOutputVector());
  }//GEN-LAST:event_parsedVectorFunction1ValueChanged
  
  private void sumFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_sumFunction1ValueChanged
    double d = sumFunction1.getOutputValue();
    numericTextField1.setValue(d);
    arithmeticFunction1.setFirstArg(d);
  }//GEN-LAST:event_sumFunction1ValueChanged
  
  private void arithmeticFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction1ValueChanged
    numericTextField2.setValue(arithmeticFunction1.getResult());
  }//GEN-LAST:event_arithmeticFunction1ValueChanged
  
  private void uniformRandomVector2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_uniformRandomVector2ValueChanged
    pointView1.setModel(uniformRandomVector1.getOutputVector(), uniformRandomVector2.getOutputVector());
    parsedVectorFunction1.setInputVector(1, uniformRandomVector2.getOutputVector());
    parsedVectorFunction1.trigger();
  }//GEN-LAST:event_uniformRandomVector2ValueChanged
  
  private void uniformRandomVector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_uniformRandomVector1ValueChanged
    parsedVectorFunction1.setInputVector(0, uniformRandomVector1.getOutputVector());
  }//GEN-LAST:event_uniformRandomVector1ValueChanged
  
  private void integerTextSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_integerTextSlider1PropertyChange
    int n = integerTextSlider1.getValueAsInt();
    uniformRandomVector1.setOutputSize(n);
    uniformRandomVector2.setOutputSize(n);
    arithmeticFunction1.setSecondArg(n);
  }//GEN-LAST:event_integerTextSlider1PropertyChange
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.ArithmeticFunction arithmeticFunction1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected physbeans.inout.IntegerTextSlider integerTextSlider1;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.NumericTextField numericTextField1;
  protected physbeans.inout.NumericTextField numericTextField2;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.func.ParsedVectorFunction parsedVectorFunction1;
  protected physbeans.views.PointView pointView1;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.views.SimpleFigureView simpleFigureView2;
  protected physbeans.func.SumFunction sumFunction1;
  protected physbeans.func.UniformRandomVector uniformRandomVector1;
  protected physbeans.func.UniformRandomVector uniformRandomVector2;
  // End of variables declaration//GEN-END:variables
  
}
