package physapps.mechanics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;

/**
 * base class of all simple computation applets <br>
 * contains an input and an output panel<br>
 *
 */
public class RocketEquation extends PhysBeansApplet {
  
  
  static public void main(String[] args) {
    startApp(new RocketEquation(), 330, 270);
  }
  
  /** Creates new form PhysicsApplet */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    checkedFunction1 = new physbeans.func.CheckedFunction();
    jPanel1 = new javax.swing.JPanel();
    inputPanel1 = new physbeans.inout.InputPanel();
    numericTextLine1 = new physbeans.inout.NumericTextLine();
    numericTextLine2 = new physbeans.inout.NumericTextLine();
    numericTextLine3 = new physbeans.inout.NumericTextLine();
    numericTextLine4 = new physbeans.inout.NumericTextLine();
    numericTextLine5 = new physbeans.inout.NumericTextLine();
    outputPanel1 = new physbeans.inout.OutputPanel();
    numericTextLine6 = new physbeans.inout.NumericTextLine();
    numericTextLine7 = new physbeans.inout.NumericTextLine();
    numericTextLine8 = new physbeans.inout.NumericTextLine();
    numericTextLine9 = new physbeans.inout.NumericTextLine();

    checkedFunction1.setCheckString("(m0 > 0) & (mFin > 0) & (tE0 > 0) & (v0 > 0) & (g > 0) & (mFin < m0) & (v0 < 3.0e8)");
    checkedFunction1.setFunction(new String[] {"(m0 - mFin)/tE0", "mDot*v0; mDot: (m0 - mFin)/tE0", "if(tFlight > 0, v0*log(mStart/mFin) - g*tFlight, 0.0); tFlight: if(start >= 0, tE0, (mStart - mFin)/mDot); mStart: if(start >= 0, m0, mDot*v0/g); start: mDot*v0 - m0*g; mDot: (m0 - mFin)/tE0", "if(tFlight > 0, (v0*mFin*(mStart/mFin - 1 - log(mStart/mFin))/mDot - 0.5*g*tFlight*tFlight)/1000.0 , 0.0); tFlight: if(start >= 0, tE0, (mStart - mFin)/mDot); mStart: if(start >= 0, m0, mDot*v0/g); start: mDot*v0 - m0*g; mDot: (m0 - mFin)/tE0"});
    checkedFunction1.setVariableName(new String[] {"m0", "mFin", "tE0", "v0", "g"});
    checkedFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        checkedFunction1ValueChanged(evt);
      }
    });

    jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));

    numericTextLine1.setDescription(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s2"));
    numericTextLine1.setOffset(40);
    numericTextLine1.setPrecision(5);
    numericTextLine1.setTitle(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s1"));
    numericTextLine1.setUnit("kg");
    numericTextLine1.setValue(2950000.0);
    numericTextLine1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        numericTextLine1PropertyChange(evt);
      }
    });
    numericTextLine1.addVetoableChangeListener(new java.beans.VetoableChangeListener() {
      public void vetoableChange(java.beans.PropertyChangeEvent evt)throws java.beans.PropertyVetoException {
        numericTextLine1VetoableChange(evt);
      }
    });

    inputPanel1.add(numericTextLine1);

    numericTextLine2.setDescription(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s5"));
    numericTextLine2.setOffset(40);
    numericTextLine2.setPrecision(5);
    numericTextLine2.setTitle(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s4"));
    numericTextLine2.setUnit("kg");
    numericTextLine2.setValue(1000000.0);
    numericTextLine2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        numericTextLine2PropertyChange(evt);
      }
    });
    numericTextLine2.addVetoableChangeListener(new java.beans.VetoableChangeListener() {
      public void vetoableChange(java.beans.PropertyChangeEvent evt)throws java.beans.PropertyVetoException {
        numericTextLine2VetoableChange(evt);
      }
    });

    inputPanel1.add(numericTextLine2);

    numericTextLine3.setDescription(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s8"));
    numericTextLine3.setOffset(40);
    numericTextLine3.setPrecision(5);
    numericTextLine3.setTitle(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s7"));
    numericTextLine3.setUnit("s");
    numericTextLine3.setValue(130.0);
    numericTextLine3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        numericTextLine3PropertyChange(evt);
      }
    });
    numericTextLine3.addVetoableChangeListener(new java.beans.VetoableChangeListener() {
      public void vetoableChange(java.beans.PropertyChangeEvent evt)throws java.beans.PropertyVetoException {
        numericTextLine3VetoableChange(evt);
      }
    });

    inputPanel1.add(numericTextLine3);

    numericTextLine4.setDescription(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s11"));
    numericTextLine4.setOffset(40);
    numericTextLine4.setPrecision(5);
    numericTextLine4.setTitle(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s10"));
    numericTextLine4.setUnit("m/s");
    numericTextLine4.setValue(2220.0);
    numericTextLine4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        numericTextLine4PropertyChange(evt);
      }
    });
    numericTextLine4.addVetoableChangeListener(new java.beans.VetoableChangeListener() {
      public void vetoableChange(java.beans.PropertyChangeEvent evt)throws java.beans.PropertyVetoException {
        numericTextLine4VetoableChange(evt);
      }
    });

    inputPanel1.add(numericTextLine4);

    numericTextLine5.setDescription(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s14"));
    numericTextLine5.setOffset(40);
    numericTextLine5.setPrecision(5);
    numericTextLine5.setTitle(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s13"));
    numericTextLine5.setUnit("m/s\u00b2");
    numericTextLine5.setValue(9.81);
    numericTextLine5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        numericTextLine5PropertyChange(evt);
      }
    });
    numericTextLine5.addVetoableChangeListener(new java.beans.VetoableChangeListener() {
      public void vetoableChange(java.beans.PropertyChangeEvent evt)throws java.beans.PropertyVetoException {
        numericTextLine5VetoableChange(evt);
      }
    });

    inputPanel1.add(numericTextLine5);

    jPanel1.add(inputPanel1);

    outputPanel1.setLayout(new javax.swing.BoxLayout(outputPanel1, javax.swing.BoxLayout.Y_AXIS));

    numericTextLine6.setDescription(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s17"));
    numericTextLine6.setEditable(false);
    numericTextLine6.setOffset(40);
    numericTextLine6.setPrecision(5);
    numericTextLine6.setTitle(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s16"));
    numericTextLine6.setUnit("kg/s");
    outputPanel1.add(numericTextLine6);

    numericTextLine7.setDescription(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s20"));
    numericTextLine7.setEditable(false);
    numericTextLine7.setOffset(40);
    numericTextLine7.setPrecision(5);
    numericTextLine7.setTitle(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s19"));
    numericTextLine7.setUnit("N");
    outputPanel1.add(numericTextLine7);

    numericTextLine8.setDescription(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s23"));
    numericTextLine8.setEditable(false);
    numericTextLine8.setOffset(40);
    numericTextLine8.setPrecision(5);
    numericTextLine8.setTitle(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s22"));
    numericTextLine8.setUnit("m/s");
    outputPanel1.add(numericTextLine8);

    numericTextLine9.setDescription(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s26"));
    numericTextLine9.setEditable(false);
    numericTextLine9.setOffset(40);
    numericTextLine9.setPrecision(5);
    numericTextLine9.setTitle(java.util.ResourceBundle.getBundle("physapps.mechanics.RocketEquation", currentLocale).getString("s25"));
    numericTextLine9.setUnit("km");
    outputPanel1.add(numericTextLine9);

    jPanel1.add(outputPanel1);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

  }// </editor-fold>//GEN-END:initComponents
  
  private void checkedFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_checkedFunction1ValueChanged
    numericTextLine6.setValue(checkedFunction1.getOutputValues(0));
    numericTextLine7.setValue(checkedFunction1.getOutputValues(1));
    numericTextLine8.setValue(checkedFunction1.getOutputValues(2));
    numericTextLine9.setValue(checkedFunction1.getOutputValues(3));
  }//GEN-LAST:event_checkedFunction1ValueChanged
    
  private void numericTextLine5VetoableChange(java.beans.PropertyChangeEvent evt) throws java.beans.PropertyVetoException {//GEN-FIRST:event_numericTextLine5VetoableChange
    checkedFunction1.checkValue(4, evt);
  }//GEN-LAST:event_numericTextLine5VetoableChange
  
  private void numericTextLine4VetoableChange(java.beans.PropertyChangeEvent evt) throws java.beans.PropertyVetoException {//GEN-FIRST:event_numericTextLine4VetoableChange
    checkedFunction1.checkValue(3, evt);
  }//GEN-LAST:event_numericTextLine4VetoableChange
  
  private void numericTextLine3VetoableChange(java.beans.PropertyChangeEvent evt) throws java.beans.PropertyVetoException {//GEN-FIRST:event_numericTextLine3VetoableChange
    checkedFunction1.checkValue(2, evt);
  }//GEN-LAST:event_numericTextLine3VetoableChange
  
  private void numericTextLine2VetoableChange(java.beans.PropertyChangeEvent evt) throws java.beans.PropertyVetoException {//GEN-FIRST:event_numericTextLine2VetoableChange
    checkedFunction1.checkValue(1, evt);
  }//GEN-LAST:event_numericTextLine2VetoableChange
  
  private void numericTextLine1VetoableChange(java.beans.PropertyChangeEvent evt) throws java.beans.PropertyVetoException {//GEN-FIRST:event_numericTextLine1VetoableChange
    checkedFunction1.checkValue(0, evt);
  }//GEN-LAST:event_numericTextLine1VetoableChange
  
  private void numericTextLine5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_numericTextLine5PropertyChange
    checkedFunction1.singleInputValue(4, numericTextLine5.getValue());
  }//GEN-LAST:event_numericTextLine5PropertyChange
  
  private void numericTextLine4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_numericTextLine4PropertyChange
    checkedFunction1.singleInputValue(3, numericTextLine4.getValue());
  }//GEN-LAST:event_numericTextLine4PropertyChange
  
  private void numericTextLine3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_numericTextLine3PropertyChange
    checkedFunction1.singleInputValue(2, numericTextLine3.getValue());
  }//GEN-LAST:event_numericTextLine3PropertyChange
  
  private void numericTextLine2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_numericTextLine2PropertyChange
    checkedFunction1.singleInputValue(1, numericTextLine2.getValue());
  }//GEN-LAST:event_numericTextLine2PropertyChange
  
  private void numericTextLine1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_numericTextLine1PropertyChange
    checkedFunction1.singleInputValue(0, numericTextLine1.getValue());
  }//GEN-LAST:event_numericTextLine1PropertyChange
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.CheckedFunction checkedFunction1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.NumericTextLine numericTextLine1;
  protected physbeans.inout.NumericTextLine numericTextLine2;
  protected physbeans.inout.NumericTextLine numericTextLine3;
  protected physbeans.inout.NumericTextLine numericTextLine4;
  protected physbeans.inout.NumericTextLine numericTextLine5;
  protected physbeans.inout.NumericTextLine numericTextLine6;
  protected physbeans.inout.NumericTextLine numericTextLine7;
  protected physbeans.inout.NumericTextLine numericTextLine8;
  protected physbeans.inout.NumericTextLine numericTextLine9;
  protected physbeans.inout.OutputPanel outputPanel1;
  // End of variables declaration//GEN-END:variables
  
}
