package physapps.nonlinear;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class TwoSpringsTransversal extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new TwoSpringsTransversal(), 650, 570);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    generic1DMassPoint1 = new physbeans.phys.Generic1DMassPoint();
    springChainView1 = new physbeans.views.SpringChainView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();

    generic1DMassPoint1.setAbsoluteTolerance(1.0E-10);
    generic1DMassPoint1.setFunction("-x +p*x/sqrt(x*x+1) -q");
    generic1DMassPoint1.setParameter(DVector.valueOf("[0.0,0.0]"));
    generic1DMassPoint1.setParameterName(new String[] {"p", "q"});
    generic1DMassPoint1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        generic1DMassPoint1ValueChanged(evt);
        generic1DMassPoint1ValueChanged1(evt);
      }
    });

    springChainView1.setInitialDisplacements(DVector.valueOf("[1.0]"));
    springChainView1.setMassScale(0.3);
    springChainView1.setSpringScale(0.3);
    springChainView1.setSquare(false);
    springChainView1.setTransversal(true);
    springChainView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        springChainView1SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.LINE_AXIS));

    objectPanel1.setPreferredSize(new java.awt.Dimension(200, 100));
    objectPanel1.setLayout(new javax.swing.BoxLayout(objectPanel1, javax.swing.BoxLayout.LINE_AXIS));

    layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen1.setBordered(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(2.0);
    layeredScreen1.setMinX(0.0);
    layeredScreen1.setOpaque(true);
    objectPanel1.add(layeredScreen1);

    jPanel2.add(objectPanel1);

    outputPanel1.setPreferredSize(new java.awt.Dimension(300, 100));

    oscilloscope1.setLineActive(new boolean[]{true,true});
    oscilloscope1.setMaxY(7.0);
    oscilloscope1.setMinY(-7.0);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.nonlinear.TwoSpringsTransversal", currentLocale); // NOI18N
    oscilloscope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    oscilloscope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    outputPanel1.add(oscilloscope1);

    jPanel2.add(outputPanel1);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel1.setLayout(new java.awt.GridLayout(2, 3));

    timer1.setDelay(15L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
        timer1Restart2(evt);
      }
    });
    inputPanel1.add(timer1);

    textSlider1.setDescription("x(0) =");
    textSlider1.setModel(new BoundedRealModel(-5.0,0.0,5.0));
    textSlider1.setUnit("");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
        textSlider1PropertyChange1(evt);
      }
    });
    inputPanel1.add(textSlider1);

    textSlider2.setDescription("v(0) =");
    textSlider2.setModel(new BoundedRealModel(-5.0,1.0,5.0));
    textSlider2.setUnit("");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider2);

    switchBox1.setBoxLabel(new String[] {
      bundle.getString("position"),
      bundle.getString("velocity")
    });
    switchBox1.setSelected(new boolean[]{true,true});
    switchBox1.setTitle(bundle.getString("osciShows")); // NOI18N
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    inputPanel1.add(switchBox1);

    textSlider4.setDescription("p =");
    textSlider4.setModel(new BoundedRealModel(-3.0,3.0,6.0));
    textSlider4.setUnit("");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider4);

    textSlider3.setDescription("q =");
    textSlider3.setModel(new BoundedRealModel(0.0,0.8,2.0));
    textSlider3.setUnit("");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider3);

    jPanel1.add(inputPanel1, java.awt.BorderLayout.NORTH);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents
  
  private void springChainView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_springChainView1SourceChanged
    layeredScreen1.addView(springChainView1);
  }//GEN-LAST:event_springChainView1SourceChanged
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    generic1DMassPoint1.setParameter(0, textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void timer1Restart2(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart2
    springChainView1.restart();
  }//GEN-LAST:event_timer1Restart2
  
  private void textSlider1PropertyChange1(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange1
    springChainView1.setInitialDisplacement(0, textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange1
  
  private void generic1DMassPoint1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_generic1DMassPoint1ValueChanged1
    springChainView1.setDisplacements(new DVector(generic1DMassPoint1.getOutputValue()));
  }//GEN-LAST:event_generic1DMassPoint1ValueChanged1
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    generic1DMassPoint1.setParameter(1, textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void generic1DMassPoint1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_generic1DMassPoint1ValueChanged
    oscilloscope1.setInputVector(generic1DMassPoint1.getOutputVector());
  }//GEN-LAST:event_generic1DMassPoint1ValueChanged
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    generic1DMassPoint1.setV0(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    generic1DMassPoint1.setX0(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    generic1DMassPoint1.restart();
  }//GEN-LAST:event_timer1Restart1
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    generic1DMassPoint1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.phys.Generic1DMassPoint generic1DMassPoint1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.views.SpringChainView springChainView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.Timer timer1;
  // End of variables declaration//GEN-END:variables
  
}
