package physapps.nuclearphysics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for wide simulation applets<br>
 * contains an input, object and output panel<br>
 * expects classes SpecialText and ResourceBundles for all texts
 */
public class RadioactiveDecay3 extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new RadioactiveDecay3(), 595, 505);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    radioactiveDecayChain1 = new physbeans.phys.RadioactiveDecayChain();
    particleDecayChain1 = new physbeans.phys.ParticleDecayChain();
    particleStateView1 = new physbeans.views.ParticleStateView();
    multiplexer1 = new physbeans.func.Multiplexer();
    arithmeticFunction1 = new physbeans.func.ArithmeticFunction();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    integerTextSlider1 = new physbeans.inout.IntegerTextSlider();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();
    
    radioactiveDecayChain1.setTHalf(DVector.valueOf("[8.0,8.0,Infinity]"));
    radioactiveDecayChain1.setInitialValues(DVector.valueOf("[100.0,0.0,0.0]"));
    radioactiveDecayChain1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        radioactiveDecayChain1ValueChanged(evt);
      }
    });
    
    particleDecayChain1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        particleDecayChain1ValueChanged(evt);
      }
    });
    
    particleStateView1.setParticleColor(2, Color.black);
    particleStateView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        particleStateView1SourceChanged(evt);
      }
    });
    
    multiplexer1.setInputLength(5);
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });
    
    arithmeticFunction1.setFirstOp(3);
    arithmeticFunction1.setSecondArg(100.0);
    arithmeticFunction1.setSecondOp(2);
    arithmeticFunction1.setThirdArg(100.0);
    arithmeticFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction1ValueChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel2.setFont(standardFont);
    jPanel2.setPreferredSize(new java.awt.Dimension(365, 500));
    objectPanel1.setPreferredSize(new java.awt.Dimension(210, 230));
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel1);
    
    outputPanel1.setPreferredSize(new java.awt.Dimension(100, 270));
    oscilloscope1.setNLines(5);
    oscilloscope1.setLineActive(new boolean[]{true,true,false,false,false});
    oscilloscope1.setMaxY(100.0);
    oscilloscope1.setMinY(0.0);
    oscilloscope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveDecay3", currentLocale).getString("osciPosition"));
    oscilloscope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveDecay3", currentLocale).getString("osciScale"));
    outputPanel1.add(oscilloscope1);
    
    jPanel2.add(outputPanel1);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    timer1.setDelay(25L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveDecay3", currentLocale).getString("timerLabel"));
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
        timer1NextStep1(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    
    inputPanel1.add(timer1);
    
    integerTextSlider1.setDescription("N_1(0) =");
    integerTextSlider1.setLogarithmic(true);
    integerTextSlider1.setModel(new BoundedRealModel(1.0,100.0,1000.0));
    integerTextSlider1.setUnit("");
    integerTextSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        integerTextSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(integerTextSlider1);
    
    textSlider1.setDescription("T\u00bd(1) =");
    textSlider1.setLogarithmic(true);
    textSlider1.setModel(new BoundedRealModel(1.0,8.0,50.0));
    textSlider1.setUnit("s");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
        textSlider1PropertyChange1(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider2.setDescription("T\u00bd(2) =");
    textSlider2.setLogarithmic(true);
    textSlider2.setModel(new BoundedRealModel(1.0,8.0,50.0));
    textSlider2.setUnit("s");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    switchBox1.setBoxLabel( new String[] {
      java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveDecay3", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveDecay3", currentLocale).getString("s2"),
      java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveDecay3", currentLocale).getString("s3"),
      java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveDecay3", currentLocale).getString("s4"),
      java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveDecay3", currentLocale).getString("s5")
    });
    switchBox1.setSelected(new boolean[]{true,true,false,false,false});
    switchBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.nuclearphysics.RadioactiveDecay3", currentLocale).getString("s6"));
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    
    inputPanel1.add(switchBox1);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void timer1NextStep1(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep1
    
  }//GEN-LAST:event_timer1NextStep1
  
  private void textSlider1PropertyChange1(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange1
    radioactiveDecayChain1.setTHalf(0, textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange1
  
  private void particleStateView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_particleStateView1SourceChanged
    layeredScreen1.addView(particleStateView1);
  }//GEN-LAST:event_particleStateView1SourceChanged
  
  private void radioactiveDecayChain1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_radioactiveDecayChain1ValueChanged
    DVector val = radioactiveDecayChain1.getOutputVector();
    multiplexer1.setInputValues(0, val.get(0));
    multiplexer1.setInputValues(1, val.get(1));
  }//GEN-LAST:event_radioactiveDecayChain1ValueChanged
  
  private void particleDecayChain1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_particleDecayChain1ValueChanged
    DVector v = particleDecayChain1.getOutputVector();
    multiplexer1.setInputValues(2, v.get(0));
    multiplexer1.setInputValues(3, v.get(1));
    arithmeticFunction1.setFirstArg(v.get(1));
    arithmeticFunction1.setSecondArg(v.get(0));
    particleStateView1.setModel(particleDecayChain1.getStates());
  }//GEN-LAST:event_particleDecayChain1ValueChanged
  
  private void arithmeticFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction1ValueChanged
    multiplexer1.setInputValues(4, arithmeticFunction1.getResult());
  }//GEN-LAST:event_arithmeticFunction1ValueChanged
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    double val = textSlider2.getValue();
    radioactiveDecayChain1.setTHalf(1, val);
    particleDecayChain1.setTHalf2(val);
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    oscilloscope1.setInputVector(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    particleDecayChain1.setTHalf1(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void integerTextSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_integerTextSlider1PropertyChange
    radioactiveDecayChain1.setInitialValue(0, integerTextSlider1.getValue());
    particleDecayChain1.setN0(integerTextSlider1.getValueAsInt());
  }//GEN-LAST:event_integerTextSlider1PropertyChange
  
        private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
          oscilloscope1.restart();
          particleDecayChain1.restart();
          radioactiveDecayChain1.restart();
  }//GEN-LAST:event_timer1Restart
        
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    particleDecayChain1.setTime(timer1.getTime());
    radioactiveDecayChain1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.ArithmeticFunction arithmeticFunction1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected physbeans.inout.IntegerTextSlider integerTextSlider1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.ParticleDecayChain particleDecayChain1;
  protected physbeans.views.ParticleStateView particleStateView1;
  protected physbeans.phys.RadioactiveDecayChain radioactiveDecayChain1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.Timer timer1;
// End of variables declaration//GEN-END:variables
  
}
