package physapps.optics;
import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel in "high" layout.
 */
public class DivergingThickLens extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new DivergingThickLens(), 620, 420);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    objectLightSource1 = new physbeans.phys.ObjectLightSource();
    objectLightSourceView1 = new physbeans.views.ObjectLightSourceView();
    objectLightSourceView2 = new physbeans.views.ObjectLightSourceView();
    thickLens1 = new physbeans.phys.ThickLens();
    lensView1 = new physbeans.views.LensView();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    jPanel1 = new javax.swing.JPanel();
    inputPanel = new physbeans.inout.PhysicsPanel();
    physicsPanel1 = new physbeans.inout.PhysicsPanel();
    switchBox1 = new physbeans.inout.SwitchBox();
    switchBox2 = new physbeans.inout.SwitchBox();
    physicsPanel2 = new physbeans.inout.PhysicsPanel();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    
    objectLightSource1.setAngle(0.157);
    objectLightSource1.setHeight(1.5);
    objectLightSource1.setPosition(-5.0);
    objectLightSource1.setRefElement(thickLens1);
    objectLightSource1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        objectLightSource1SourceChanged(evt);
      }
    });
    
    objectLightSourceView1.setArrowWidth(1.0);
    objectLightSourceView1.setObjectColor(new java.awt.Color(0, 255, 0));
    objectLightSourceView1.setShowRays(new boolean[]{true,true,false,false});
    objectLightSourceView2.setArrowWidth(1.0);
    objectLightSourceView2.setDepth(60);
    objectLightSourceView2.setRayColor(new java.awt.Color(102, 204, 255));
    objectLightSourceView2.setShowRays(new boolean[]{true,true,false,false});
    thickLens1.setIndexOfRefraction(1.613);
    thickLens1.setMaxHeight(15.0);
    thickLens1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        thickLens1SourceChanged(evt);
      }
    });
    
    lensView1.setDepth(70);
    lensView1.setFocalPointRadius(0.85);
    lensView1.setShowFocalPoints(true);
    lensView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        lensView1SourceChanged(evt);
      }
    });
    
    simpleFigureView1.setDepth(40);
    simpleFigureView1.setFigureType(0);
    simpleFigureView1.setP1(DVector.valueOf("[-60.0,0.0]"));
    simpleFigureView1.setP2(DVector.valueOf("[60.0,0.0]"));
    
    jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.X_AXIS));
    
    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    physicsPanel1.setLayout(new javax.swing.BoxLayout(physicsPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    switchBox1.setBoxLabel( new String[] {
      java.util.ResourceBundle.getBundle("physapps.optics.DivergingThickLens", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.optics.DivergingThickLens", currentLocale).getString("s2"),
      java.util.ResourceBundle.getBundle("physapps.optics.DivergingThickLens", currentLocale).getString("s3"),
      java.util.ResourceBundle.getBundle("physapps.optics.DivergingThickLens", currentLocale).getString("s4")
    });
    switchBox1.setSelected(new boolean[]{true,true,false,false});
    switchBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.optics.DivergingThickLens", currentLocale).getString("s5"));
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    
    physicsPanel1.add(switchBox1);
    
    switchBox2.setBoxLabel( new String[] {
      java.util.ResourceBundle.getBundle("physapps.optics.DivergingThickLens", currentLocale).getString("s6"),
    });
    switchBox2.setSelected(new boolean[]{true});
    switchBox2.setTitle("");
    switchBox2.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox2ValueChanged(evt);
      }
    });
    
    physicsPanel1.add(switchBox2);
    
    inputPanel.add(physicsPanel1);
    
    physicsPanel2.setLayout(new java.awt.GridLayout(2, 3));
    
    textSlider1.setDescription("a =");
    textSlider1.setModel(new BoundedRealModel(-60.0,-35.0,-1.0));
    textSlider1.setUnit("cm");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    physicsPanel2.add(textSlider1);
    
    textSlider2.setDescription("r =");
    textSlider2.setModel(new BoundedRealModel(5.0,30.0,60.0));
    textSlider2.setUnit("cm");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    physicsPanel2.add(textSlider2);
    
    textSlider3.setDescription("y =");
    textSlider3.setModel(new BoundedRealModel(-12.0,8.0,12.0));
    textSlider3.setUnit("cm");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    physicsPanel2.add(textSlider3);
    
    textSlider5.setDescription("d =");
    textSlider5.setModel(new BoundedRealModel(0.1,6.0,20.0));
    textSlider5.setUnit("cm");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    
    physicsPanel2.add(textSlider5);
    
    inputPanel.add(physicsPanel2);
    
    jPanel1.add(inputPanel);
    
    objectPanel1.setBordered(true);
    objectPanel1.setPreferredSize(new java.awt.Dimension(200, 200));
    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(50.0);
    layeredScreen1.setMinX(-50.0);
    layeredScreen1.setViewActive(new boolean[]{true,true,true,true});
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel1.add(objectPanel1);
    
    outputPanel1.setLayout(new java.awt.FlowLayout());
    
    outputPanel1.setPreferredSize(new java.awt.Dimension(50, 20));
    vectorTextField1.setHorizontal(true);
    vectorTextField1.setPadding(30);
    vectorTextField1.setUnit(new String[] {"cm", "cm"});
    outputPanel1.add(vectorTextField1);
    
    jPanel1.add(outputPanel1);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void lensView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_lensView1SourceChanged
    layeredScreen1.addView(lensView1);
    layeredScreen1.addView(objectLightSourceView2);
    layeredScreen1.addView(objectLightSourceView1);
    layeredScreen1.addView(simpleFigureView1);
  }//GEN-LAST:event_lensView1SourceChanged
  
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    thickLens1.setThickness(textSlider5.getValue());
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void thickLens1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_thickLens1SourceChanged
    lensView1.setModel(thickLens1);
    objectLightSource1.trigger();
  }//GEN-LAST:event_thickLens1SourceChanged
  
  private void switchBox2ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox2ValueChanged
    layeredScreen1.setViewActive(1, switchBox2.getSelected(0));
  }//GEN-LAST:event_switchBox2ValueChanged
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    objectLightSourceView1.setShowRays(switchBox1.getSelected());
    objectLightSourceView2.setShowRays(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void objectLightSource1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_objectLightSource1SourceChanged
    objectLightSourceView1.setModel(objectLightSource1);
    thickLens1.propagate(objectLightSource1.getRays());
    objectLightSourceView2.setModel(thickLens1.getImage(objectLightSource1));
  }//GEN-LAST:event_objectLightSource1SourceChanged
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    double val = textSlider2.getValue();
    thickLens1.setRadius1(-val);
    thickLens1.setRadius2(val);
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    objectLightSource1.setPosition(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    vectorTextField1.setValue(layeredScreen1.getClickedPosition());
  }//GEN-LAST:event_layeredScreen1ValueChanged
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    objectLightSource1.setHeight(textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.views.LensView lensView1;
  protected physbeans.phys.ObjectLightSource objectLightSource1;
  protected physbeans.views.ObjectLightSourceView objectLightSourceView1;
  protected physbeans.views.ObjectLightSourceView objectLightSourceView2;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.inout.PhysicsPanel physicsPanel1;
  protected physbeans.inout.PhysicsPanel physicsPanel2;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.SwitchBox switchBox2;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.phys.ThickLens thickLens1;
  protected physbeans.inout.VectorTextField vectorTextField1;
// End of variables declaration//GEN-END:variables
  
}
