package physapps.optics;
import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel in "high" layout.
 */
public class Microscope extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new Microscope(),565, 420);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    objectLightSource1 = new physbeans.phys.ObjectLightSource();
    objectLightSourceView1 = new physbeans.views.ObjectLightSourceView();
    objectLightSourceView2 = new physbeans.views.ObjectLightSourceView();
    lens1 = new physbeans.phys.ThinLens();
    lensView1 = new physbeans.views.LensView();
    lens2 = new physbeans.phys.ThinLens();
    lensView2 = new physbeans.views.LensView();
    opticalBench1 = new physbeans.phys.OpticalBench();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    jPanel1 = new javax.swing.JPanel();
    inputPanel1 = new physbeans.inout.InputPanel();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    
    objectLightSource1.setAngle(0.8);
    objectLightSource1.setHeight(1.0);
    objectLightSource1.setRefElement(lens1);
    objectLightSource1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        objectLightSource1SourceChanged(evt);
      }
    });
    
    objectLightSourceView1.setArrowWidth(0.6);
    objectLightSourceView1.setObjectColor(new java.awt.Color(0, 255, 0));
    objectLightSourceView1.setShowRays(new boolean[]{true,true,true,true});
    objectLightSourceView2.setArrowWidth(0.6);
    objectLightSourceView2.setDepth(40);
    objectLightSourceView2.setShowRays(new boolean[]{false,false,false,false});
    lens1.setMaxHeight(9.0);
    lens1.setPosition(10.0);
    lens1.setRadius1(40.0);
    lens1.setRadius2(-40.0);
    lens1.setThickness(2.0);
    lens1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        lens1SourceChanged(evt);
      }
    });
    
    lensView1.setDepth(70);
    lensView1.setFocalPointRadius(0.5);
    lensView1.setShowFocalPoints(true);
    lens2.setMaxHeight(9.0);
    lens2.setPosition(40.0);
    lens2.setRadius1(40.0);
    lens2.setRadius2(-40.0);
    lens2.setThickness(2.0);
    lens2.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        lens2SourceChanged(evt);
      }
    });
    
    lensView2.setDepth(60);
    lensView2.setFocalPointRadius(0.5);
    lensView2.setShowFocalPoints(true);
    simpleFigureView1.setDepth(30);
    simpleFigureView1.setFigureType(0);
    simpleFigureView1.setP2(DVector.valueOf("[50.0,0.0]"));
    simpleFigureView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        simpleFigureView1SourceChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    inputPanel1.setLayout(new java.awt.GridLayout(2, 2));
    
    inputPanel1.setAlignmentX(0.5F);
    textSlider1.setDescription("d =");
    textSlider1.setModel(new BoundedRealModel(0.0010,0.5,1.0));
    textSlider1.setUnit("cm");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider4.setDescription("f1 =");
    textSlider4.setModel(new BoundedRealModel(1.0,3.0,5.0));
    textSlider4.setUnit("cm");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider4);
    
    textSlider2.setDescription("y =");
    textSlider2.setModel(new BoundedRealModel(0.0,0.75,2.0));
    textSlider2.setUnit("cm");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider3.setDescription("f2 =");
    textSlider3.setModel(new BoundedRealModel(1.0,2.5,5.0));
    textSlider3.setUnit("cm");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    jPanel1.add(inputPanel1);
    
    objectPanel1.setPreferredSize(new java.awt.Dimension(200, 250));
    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(50.0);
    layeredScreen1.setMinX(0.0);
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel1.add(objectPanel1);
    
    outputPanel1.setLayout(new java.awt.FlowLayout());
    
    vectorTextField1.setHorizontal(true);
    vectorTextField1.setPadding(30);
    vectorTextField1.setUnit(new String[] {"cm", "cm"});
    outputPanel1.add(vectorTextField1);
    
    jPanel1.add(outputPanel1);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents

  private void simpleFigureView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_simpleFigureView1SourceChanged
    layeredScreen1.addView(lensView1);
    layeredScreen1.addView(lensView2);
    layeredScreen1.addView(objectLightSourceView1);
    layeredScreen1.addView(objectLightSourceView2);
    layeredScreen1.addView(simpleFigureView1);
  }//GEN-LAST:event_simpleFigureView1SourceChanged
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    objectLightSource1.setHeight(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void objectLightSource1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_objectLightSource1SourceChanged
    opticalBench1.addLightSource(objectLightSource1);
    objectLightSourceView1.setModel(objectLightSource1);
    objectLightSourceView2.setModel(lens1.getImage(objectLightSource1));
  }//GEN-LAST:event_objectLightSource1SourceChanged
  
  private void lens2SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_lens2SourceChanged
    opticalBench1.addOpticalElement(lens2);
    lensView2.setModel(lens2);
  }//GEN-LAST:event_lens2SourceChanged
  
  private void lens1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_lens1SourceChanged
    opticalBench1.addOpticalElement(lens1);
    lensView1.setModel(lens1);
  }//GEN-LAST:event_lens1SourceChanged
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    double val = textSlider1.getValue();
    objectLightSource1.setPosition(10 - val - lens1.getFocalLength());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    double f1 = textSlider4.getValue();
    lens1.setFocalLength(f1);
    objectLightSource1.setPosition(10 - textSlider1.getValue() - f1);
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    double f2 = textSlider3.getValue();
    lens2.setFocalLength(f2);
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    vectorTextField1.setValue(layeredScreen1.getClickedPosition());
  }//GEN-LAST:event_layeredScreen1ValueChanged
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.ThinLens lens1;
  protected physbeans.phys.ThinLens lens2;
  protected physbeans.views.LensView lensView1;
  protected physbeans.views.LensView lensView2;
  protected physbeans.phys.ObjectLightSource objectLightSource1;
  protected physbeans.views.ObjectLightSourceView objectLightSourceView1;
  protected physbeans.views.ObjectLightSourceView objectLightSourceView2;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.phys.OpticalBench opticalBench1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.VectorTextField vectorTextField1;
// End of variables declaration//GEN-END:variables
  
}
