package physapps.optics;
import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel in "high" layout.
 */
public class OpticalResonator extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new OpticalResonator(), 650, 420);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    pointLightSource1 = new physbeans.phys.PointLightSource();
    pointLightSourceView1 = new physbeans.views.PointLightSourceView();
    sphericalMirror1 = new physbeans.phys.SphericalMirror();
    sphericalMirrorView1 = new physbeans.views.SphericalMirrorView();
    sphericalMirror2 = new physbeans.phys.SphericalMirror();
    sphericalMirrorView2 = new physbeans.views.SphericalMirrorView();
    opticalBench1 = new physbeans.phys.OpticalBench();
    jPanel1 = new javax.swing.JPanel();
    inputPanel1 = new physbeans.inout.InputPanel();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider6 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    
    pointLightSource1.setNRays(9);
    pointLightSource1.setPosition(-9.0);
    pointLightSource1.setSpreadAngle(0.25);
    pointLightSource1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        pointLightSource1SourceChanged(evt);
      }
    });
    
    pointLightSourceView1.setDepth(40);
    pointLightSourceView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        pointLightSourceView1SourceChanged(evt);
      }
    });
    
    sphericalMirror1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        sphericalMirror1SourceChanged(evt);
      }
    });
    
    sphericalMirrorView1.setDepth(60);
    sphericalMirror2.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        sphericalMirror2SourceChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    inputPanel1.setLayout(new java.awt.GridLayout(2, 3));
    
    inputPanel1.setAlignmentX(0.5F);
    textSlider2.setDescription("x =");
    textSlider2.setModel(new BoundedRealModel(-1.0,5.0,11.0));
    textSlider2.setUnit("cm");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider5.setDescription("\u03b1 =");
    textSlider5.setModel(new BoundedRealModel(-1.0,0.2009,1.0));
    textSlider5.setUnit("\u03c0");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider5);
    
    textSlider4.setDescription("r1 =");
    textSlider4.setModel(new BoundedRealModel(2.0,5.0,20.0));
    textSlider4.setUnit("cm");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider4);
    
    textSlider1.setDescription("y =");
    textSlider1.setModel(new BoundedRealModel(-5.0,0.0,5.0));
    textSlider1.setUnit("cm");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider6.setDescription("d =");
    textSlider6.setModel(new BoundedRealModel(0.0,8.0,10.0));
    textSlider6.setUnit("cm");
    textSlider6.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider6PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider6);
    
    textSlider3.setDescription("r2 =");
    textSlider3.setModel(new BoundedRealModel(2.0,5.0,20.0));
    textSlider3.setUnit("cm");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    jPanel1.add(inputPanel1);
    
    objectPanel1.setPreferredSize(new java.awt.Dimension(200, 250));
    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(11.0);
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel1.add(objectPanel1);
    
    outputPanel1.setLayout(new java.awt.FlowLayout());
    
    outputPanel1.setPreferredSize(new java.awt.Dimension(50, 30));
    vectorTextField1.setHorizontal(true);
    vectorTextField1.setPadding(30);
    vectorTextField1.setUnit(new String[] {"cm", "cm"});
    outputPanel1.add(vectorTextField1);
    
    jPanel1.add(outputPanel1);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void pointLightSourceView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pointLightSourceView1SourceChanged
    layeredScreen1.addView(pointLightSourceView1);
    layeredScreen1.addView(sphericalMirrorView1);
    layeredScreen1.addView(sphericalMirrorView2);
  }//GEN-LAST:event_pointLightSourceView1SourceChanged
  
  private void textSlider6PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider6PropertyChange
    sphericalMirror2.setPosition(textSlider6.getValue());
  }//GEN-LAST:event_textSlider6PropertyChange
  
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    pointLightSource1.setMidAngle(textSlider5.getValue()*Math.PI);
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    sphericalMirror1.setRadius(textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void sphericalMirror2SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_sphericalMirror2SourceChanged
    opticalBench1.addOpticalElement(sphericalMirror2);
    sphericalMirrorView2.setModel(sphericalMirror2);
  }//GEN-LAST:event_sphericalMirror2SourceChanged
  
  private void pointLightSource1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pointLightSource1SourceChanged
    pointLightSourceView1.setModel(pointLightSource1);
    opticalBench1.addLightSource(pointLightSource1);
  }//GEN-LAST:event_pointLightSource1SourceChanged
  
  private void sphericalMirror1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_sphericalMirror1SourceChanged
    opticalBench1.addOpticalElement(sphericalMirror1);
    sphericalMirrorView1.setModel(sphericalMirror1);
  }//GEN-LAST:event_sphericalMirror1SourceChanged
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    sphericalMirror2.setRadius(-textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    pointLightSource1.setPosition(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    vectorTextField1.setValue(layeredScreen1.getClickedPosition());
  }//GEN-LAST:event_layeredScreen1ValueChanged
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    pointLightSource1.setHeight(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.phys.OpticalBench opticalBench1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.PointLightSource pointLightSource1;
  protected physbeans.views.PointLightSourceView pointLightSourceView1;
  protected physbeans.phys.SphericalMirror sphericalMirror1;
  protected physbeans.phys.SphericalMirror sphericalMirror2;
  protected physbeans.views.SphericalMirrorView sphericalMirrorView1;
  protected physbeans.views.SphericalMirrorView sphericalMirrorView2;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.inout.TextSlider textSlider6;
  protected physbeans.inout.VectorTextField vectorTextField1;
// End of variables declaration//GEN-END:variables
  
}
