package physapps.optics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class SubtractiveColorMixture extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new SubtractiveColorMixture(), 550, 340);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    threeColorMixer1 = new physbeans.phys.ThreeColorMixer();
    threeColorMixerView1 = new physbeans.views.ThreeColorMixerView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    inputPanel = new physbeans.inout.PhysicsPanel();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();

    threeColorMixer1.setAdditive(false);
    threeColorMixer1.setFirstPrimary(new java.awt.Color(0, 255, 255));
    threeColorMixer1.setSecondPrimary(new java.awt.Color(255, 0, 255));
    threeColorMixer1.setThirdPrimary(new java.awt.Color(255, 255, 0));
    threeColorMixer1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        threeColorMixer1SourceChanged(evt);
      }
    });

    threeColorMixerView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        threeColorMixerView1SourceChanged(evt);
      }
    });

    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    jPanel2.setFont(standardFont);
    objectPanel.setLayout(new java.awt.BorderLayout());

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(2.0);
    layeredScreen1.setMinX(-2.0);
    layeredScreen1.setOpaque(true);
    objectPanel.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    textSlider1.setDescription(java.util.ResourceBundle.getBundle("physapps/optics/SubtractiveColorMixture").getString("r"));
    textSlider1.setModel(new BoundedRealModel(0.0,1.0,1.0));
    textSlider1.setUnit("");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });

    inputPanel.add(textSlider1);

    textSlider2.setDescription(java.util.ResourceBundle.getBundle("physapps/optics/SubtractiveColorMixture").getString("g"));
    textSlider2.setModel(new BoundedRealModel(0.0,1.0,1.0));
    textSlider2.setUnit("");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });

    inputPanel.add(textSlider2);

    textSlider3.setDescription(java.util.ResourceBundle.getBundle("physapps/optics/SubtractiveColorMixture").getString("b"));
    textSlider3.setModel(new BoundedRealModel(0.0,1.0,1.0));
    textSlider3.setUnit("");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });

    inputPanel.add(textSlider3);

    jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

  }// </editor-fold>//GEN-END:initComponents

  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    threeColorMixer1.setScale(2, textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange

  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    threeColorMixer1.setScale(1, textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange

  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    threeColorMixer1.setScale(0, textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange

  private void threeColorMixer1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_threeColorMixer1SourceChanged
    threeColorMixerView1.setModel(threeColorMixer1.getScaledColors());
  }//GEN-LAST:event_threeColorMixer1SourceChanged

  private void threeColorMixerView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_threeColorMixerView1SourceChanged
    layeredScreen1.addView(threeColorMixerView1);
  }//GEN-LAST:event_threeColorMixerView1SourceChanged
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.phys.ThreeColorMixer threeColorMixer1;
  protected physbeans.views.ThreeColorMixerView threeColorMixerView1;
  // End of variables declaration//GEN-END:variables
  
}
