package physapps.quantummechanics;

import physbeans.inout.*;
import physbeans.model.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class CoulombSuperposition extends PhysBeansApplet {

  static public void main(String[] args) {
    startApp(new CoulombSuperposition(), 610, 662);
  }

  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    schroedinger2D1 = new physbeans.phys.Schroedinger2D();
    coulomb2DPotential1 = new physbeans.phys.Coulomb2DPotential();
    coulomb2DEigenfunction1 = new physbeans.phys.Coulomb2DEigenfunction();
    jetColorTable1 = new physbeans.views.JetColorTable();
    complexGridView1 = new physbeans.views.ComplexGridView();
    complexToRealFunctionAdapter1 = new physbeans.func.ComplexToRealFunctionAdapter();
    cutFunction1 = new physbeans.func.CutFunction();
    functionView1 = new physbeans.views.FunctionView();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    controlledLayeredScreen1 = new physbeans.inout.ControlledLayeredScreen();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    textSliderC1 = new physbeans.inout.TextSlider();
    vectorSliderC2 = new physbeans.inout.VectorSlider();
    vectorSliderC3 = new physbeans.inout.VectorSlider();
    vectorSliderC4 = new physbeans.inout.VectorSlider();
    radioButtonBox1 = new physbeans.inout.RadioButtonBox();

    schroedinger2D1.setXMax(3.0E-9);
    schroedinger2D1.setXMin(-3.0E-9);
    schroedinger2D1.setYMax(3.0E-9);
    schroedinger2D1.setYMin(-3.0E-9);
    schroedinger2D1.setBoundaryWidthX(2);
    schroedinger2D1.setBoundaryWidthY(2);
    schroedinger2D1.setGridSizeX(154);
    schroedinger2D1.setInitFunction(coulomb2DEigenfunction1);
    schroedinger2D1.setPotential(coulomb2DPotential1);
    schroedinger2D1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        schroedinger2D1SourceChanged(evt);
      }
    });

    coulomb2DEigenfunction1.setNEnergyLevels(4);

    complexGridView1.setColors(jetColorTable1);
    complexGridView1.setDepth(60);
    complexGridView1.setMaxVal(8.0E8);
    complexGridView1.setMinVal(-8.0E8);
    complexGridView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        complexGridView1SourceChanged(evt);
      }
    });

    complexToRealFunctionAdapter1.setYMax(1.0E9);
    complexToRealFunctionAdapter1.setYMin(-1.0E9);
    complexToRealFunctionAdapter1.setCutoff(1.0E7);
    complexToRealFunctionAdapter1.setScreen(controlledLayeredScreen1);
    complexToRealFunctionAdapter1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        complexToRealFunctionAdapter1ValueChanged(evt);
      }
    });

    cutFunction1.setNPoints(300);
    cutFunction1.setXMax(3.0E-9);
    cutFunction1.setXMin(-3.0E-9);
    cutFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        cutFunction1ValueChanged(evt);
      }
    });

    functionView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        functionView1SourceChanged(evt);
      }
    });

    simpleFigureView1.setFigureType(0);
    simpleFigureView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        simpleFigureView1SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    objectPanel.setPreferredSize(new java.awt.Dimension(106, 300));
    objectPanel.setLayout(new java.awt.BorderLayout());

    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(3.0E-9);
    layeredScreen1.setMinX(-3.0E-9);
    layeredScreen1.setViewActive(new boolean[] {true, false});
    objectPanel.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel);

    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    outputPanel.setPreferredSize(new java.awt.Dimension(316, 200));
    outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.LINE_AXIS));

    controlledLayeredScreen1.setBordered(true);
    controlledLayeredScreen1.setMaxX(3.0E-9);
    controlledLayeredScreen1.setMinX(-3.0E-9);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.quantummechanics.CoulombSuperposition", currentLocale); // NOI18N
    controlledLayeredScreen1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    controlledLayeredScreen1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    outputPanel.add(controlledLayeredScreen1);

    jPanel2.add(outputPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(30L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.setTimeIncrement(2.1010387472600993E-17);
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    inputPanel.add(timer1);

    textSliderC1.setDescription("c1 =");
    textSliderC1.setModel(new BoundedRealModel(-1.0,0.0,1.0));
    textSliderC1.setUnit("");
    textSliderC1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderC1PropertyChange(evt);
      }
    });
    inputPanel.add(textSliderC1);

    vectorSliderC2.setColumns(7);
    vectorSliderC2.setCount(3);
    vectorSliderC2.setDescription("c2 =");
    vectorSliderC2.setMinimum(-1.0);
    vectorSliderC2.setUnit("");
    vectorSliderC2.setVertical(false);
    vectorSliderC2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderC2PropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderC2);

    vectorSliderC3.setColumns(7);
    vectorSliderC3.setCount(5);
    vectorSliderC3.setDescription("c3 =");
    vectorSliderC3.setMinimum(-1.0);
    vectorSliderC3.setUnit("");
    vectorSliderC3.setVertical(false);
    vectorSliderC3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderC3PropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderC3);

    vectorSliderC4.setColumns(7);
    vectorSliderC4.setCount(7);
    vectorSliderC4.setDescription("c4 =");
    vectorSliderC4.setInitialValues(DVector.valueOf("[1.0,-0.6,0.2,0.0,0.0,-1.0,0.0]"));
    vectorSliderC4.setMinimum(-1.0);
    vectorSliderC4.setUnit("");
    vectorSliderC4.setVertical(false);
    vectorSliderC4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderC4PropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderC4);

    radioButtonBox1.setBoxLabel( new String[] {
      bundle.getString("real"), bundle.getString("imag"), bundle.getString("abs"),
      bundle.getString("abs2"), bundle.getString("phase")
    }
  );
  radioButtonBox1.setTitle(bundle.getString("Display")); // NOI18N
  radioButtonBox1.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      radioButtonBox1ValueChanged(evt);
      radioButtonBox1ValueChanged1(evt);
    }
  });
  inputPanel.add(radioButtonBox1);

  jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

  getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    schroedinger2D1.nextStep();
  }//GEN-LAST:event_timer1NextStep

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    schroedinger2D1.restart();
  }//GEN-LAST:event_timer1Restart

  private void schroedinger2D1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_schroedinger2D1SourceChanged
    complexGridView1.setModel(schroedinger2D1);
    complexToRealFunctionAdapter1.setComplexFunction(schroedinger2D1);
  }//GEN-LAST:event_schroedinger2D1SourceChanged

  private void cutFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_cutFunction1ValueChanged
    functionView1.setModel(cutFunction1.getXVector(), cutFunction1.getYVector());
  }//GEN-LAST:event_cutFunction1ValueChanged

  private void functionView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_functionView1SourceChanged
    controlledLayeredScreen1.addView(functionView1);
  }//GEN-LAST:event_functionView1SourceChanged

  private void complexGridView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_complexGridView1SourceChanged
    layeredScreen1.addView(complexGridView1);
  }//GEN-LAST:event_complexGridView1SourceChanged

  private void complexToRealFunctionAdapter1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_complexToRealFunctionAdapter1ValueChanged
    cutFunction1.setScalarField(complexToRealFunctionAdapter1);
  }//GEN-LAST:event_complexToRealFunctionAdapter1ValueChanged

  private void radioButtonBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_radioButtonBox1ValueChanged
    complexToRealFunctionAdapter1.setConversionTypeFromInt(radioButtonBox1.getSelected());
}//GEN-LAST:event_radioButtonBox1ValueChanged

  private void simpleFigureView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_simpleFigureView1SourceChanged
    layeredScreen1.addView(simpleFigureView1);
  }//GEN-LAST:event_simpleFigureView1SourceChanged

  private void textSliderC1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderC1PropertyChange
    coulomb2DEigenfunction1.setCoefficient(1, 0, textSliderC1.getValue());
  }//GEN-LAST:event_textSliderC1PropertyChange

  private void vectorSliderC2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderC2PropertyChange
    coulomb2DEigenfunction1.setCoefficientsWithNFixed(2, vectorSliderC2.getValue());
  }//GEN-LAST:event_vectorSliderC2PropertyChange

  private void vectorSliderC3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderC3PropertyChange
    coulomb2DEigenfunction1.setCoefficientsWithNFixed(3, vectorSliderC3.getValue());
  }//GEN-LAST:event_vectorSliderC3PropertyChange

  private void vectorSliderC4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderC4PropertyChange
    coulomb2DEigenfunction1.setCoefficientsWithNFixed(4, vectorSliderC4.getValue());
  }//GEN-LAST:event_vectorSliderC4PropertyChange

  private void radioButtonBox1ValueChanged1(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_radioButtonBox1ValueChanged1
    complexGridView1.setTypeFromInt(radioButtonBox1.getSelected());
  }//GEN-LAST:event_radioButtonBox1ValueChanged1

  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.views.ComplexGridView complexGridView1;
  protected physbeans.func.ComplexToRealFunctionAdapter complexToRealFunctionAdapter1;
  protected physbeans.inout.ControlledLayeredScreen controlledLayeredScreen1;
  protected physbeans.phys.Coulomb2DEigenfunction coulomb2DEigenfunction1;
  protected physbeans.phys.Coulomb2DPotential coulomb2DPotential1;
  protected physbeans.func.CutFunction cutFunction1;
  protected physbeans.views.FunctionView functionView1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.views.JetColorTable jetColorTable1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.inout.RadioButtonBox radioButtonBox1;
  protected physbeans.phys.Schroedinger2D schroedinger2D1;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.inout.TextSlider textSliderC1;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.VectorSlider vectorSliderC2;
  protected physbeans.inout.VectorSlider vectorSliderC3;
  protected physbeans.inout.VectorSlider vectorSliderC4;
  // End of variables declaration//GEN-END:variables
}
