package physapps.quantummechanics;

import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class HarmonicOscillator extends PhysBeansApplet {

  static public void main(String[] args) {
    startApp(new HarmonicOscillator(), 540, 535);
  }

  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    schroedinger2D1 = new physbeans.phys.Schroedinger2D();
    harmonic2DPotential1 = new physbeans.phys.Harmonic2DPotential();
    gaussianGridInitializer1 = new physbeans.phys.GaussianGridInitializer();
    jetColorTable1 = new physbeans.views.JetColorTable();
    complexGridView1 = new physbeans.views.ComplexGridView();
    complexToRealFunctionAdapter1 = new physbeans.func.ComplexToRealFunctionAdapter();
    cutFunction1 = new physbeans.func.CutFunction();
    functionView1 = new physbeans.views.FunctionView();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    controlledLayeredScreen1 = new physbeans.inout.ControlledLayeredScreen();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    vectorSlider1 = new physbeans.inout.VectorSlider();
    vectorSlider2 = new physbeans.inout.VectorSlider();
    textSlider1 = new physbeans.inout.TextSlider();
    radioButtonBox1 = new physbeans.inout.RadioButtonBox();
    switchBox1 = new physbeans.inout.SwitchBox();
    textSlider2 = new physbeans.inout.TextSlider();

    schroedinger2D1.setXMax(8.0E-9);
    schroedinger2D1.setXMin(-8.0E-9);
    schroedinger2D1.setYMax(8.0E-9);
    schroedinger2D1.setYMin(-8.0E-9);
    schroedinger2D1.setBoundaryWidthX(2);
    schroedinger2D1.setBoundaryWidthY(2);
    schroedinger2D1.setGridSizeX(104);
    schroedinger2D1.setInitFunction(gaussianGridInitializer1);
    schroedinger2D1.setPotential(harmonic2DPotential1);
    schroedinger2D1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        schroedinger2D1SourceChanged(evt);
      }
    });

    complexGridView1.setColors(jetColorTable1);
    complexGridView1.setDepth(60);
    complexGridView1.setMaxVal(2.0E8);
    complexGridView1.setMinVal(-2.0E8);
    complexGridView1.setType(ComplexToRealEnum.ABS2);
    complexGridView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        complexGridView1SourceChanged(evt);
      }
    });

    complexToRealFunctionAdapter1.setYMax(8.0E8);
    complexToRealFunctionAdapter1.setYMin(-8.0E8);
    complexToRealFunctionAdapter1.setConversionType(ComplexToRealEnum.ABS);
    complexToRealFunctionAdapter1.setCutoff(1.0E7);
    complexToRealFunctionAdapter1.setScreen(controlledLayeredScreen1);
    complexToRealFunctionAdapter1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        complexToRealFunctionAdapter1ValueChanged(evt);
      }
    });

    cutFunction1.setXMax(8.0E-9);
    cutFunction1.setXMin(-8.0E-9);
    cutFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        cutFunction1ValueChanged(evt);
      }
    });

    functionView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        functionView1SourceChanged(evt);
      }
    });

    simpleFigureView1.setFigureType(0);
    simpleFigureView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        simpleFigureView1SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    objectPanel.setPreferredSize(new java.awt.Dimension(106, 300));
    objectPanel.setLayout(new java.awt.BorderLayout());

    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(8.0E-9);
    layeredScreen1.setMinX(-8.0E-9);
    layeredScreen1.setViewActive(new boolean[] {true, false});
    objectPanel.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel);

    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    outputPanel.setPreferredSize(new java.awt.Dimension(316, 200));
    outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.LINE_AXIS));

    controlledLayeredScreen1.setBordered(true);
    controlledLayeredScreen1.setMaxX(8.0E-9);
    controlledLayeredScreen1.setMinX(-8.0E-9);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.quantummechanics.HarmonicOscillator", currentLocale); // NOI18N
    controlledLayeredScreen1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    controlledLayeredScreen1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    outputPanel.add(controlledLayeredScreen1);

    jPanel2.add(outputPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(30L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    inputPanel.add(timer1);

    vectorSlider1.setColumns(7);
    vectorSlider1.setCount(2);
    vectorSlider1.setDescription("x0 =");
    vectorSlider1.setInitialValues(DVector.valueOf("[-1.0E-9,0.0]"));
    vectorSlider1.setMaximum(4.0E-9);
    vectorSlider1.setMinimum(-4.0E-9);
    vectorSlider1.setUnit("m");
    vectorSlider1.setVertical(false);
    vectorSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSlider1PropertyChange(evt);
      }
    });
    inputPanel.add(vectorSlider1);

    vectorSlider2.setColumns(6);
    vectorSlider2.setCount(2);
    vectorSlider2.setDescription("v0 =");
    vectorSlider2.setInitialValues(DVector.valueOf("[300000.0,0.0]"));
    vectorSlider2.setMaximum(500000.0);
    vectorSlider2.setMinimum(-500000.0);
    vectorSlider2.setUnit("m/s");
    vectorSlider2.setVertical(false);
    vectorSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSlider2PropertyChange(evt);
      }
    });
    inputPanel.add(vectorSlider2);

    textSlider1.setColumns(6);
    textSlider1.setDescription("s =");
    textSlider1.setModel(new BoundedRealModel(1.0E-10,1.076E-9,4.0E-9));
    textSlider1.setUnit("m");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    inputPanel.add(textSlider1);

    radioButtonBox1.setBoxLabel( new String[] {
      bundle.getString("real"), bundle.getString("imag"), bundle.getString("abs"),
      bundle.getString("abs2"), bundle.getString("phase")
    }
  );
  radioButtonBox1.setSelected(2);
  radioButtonBox1.setTitle(bundle.getString("Display")); // NOI18N
  radioButtonBox1.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      radioButtonBox1ValueChanged(evt);
    }
  });
  inputPanel.add(radioButtonBox1);

  switchBox1.setBoxLabel( new String[] {bundle.getString("s1")}
  );
  switchBox1.setSelected(new boolean[] {false});
  switchBox1.setTitle("");
  switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      switchBox1ValueChanged(evt);
    }
  });
  inputPanel.add(switchBox1);

  textSlider2.setColumns(6);
  textSlider2.setDescription("y =");
  textSlider2.setModel(new BoundedRealModel(-8.0E-9,0.0,8.0E-9));
  textSlider2.setUnit("m");
  textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSlider2PropertyChange(evt);
    }
  });
  inputPanel.add(textSlider2);

  jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

  getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    schroedinger2D1.nextStep();
  }//GEN-LAST:event_timer1NextStep

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    schroedinger2D1.restart();
  }//GEN-LAST:event_timer1Restart

  private void vectorSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSlider1PropertyChange
    gaussianGridInitializer1.setX0(vectorSlider1.getValue());
  }//GEN-LAST:event_vectorSlider1PropertyChange

  private void vectorSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSlider2PropertyChange
    gaussianGridInitializer1.setV0(vectorSlider2.getValue());
  }//GEN-LAST:event_vectorSlider2PropertyChange

  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    gaussianGridInitializer1.setWidth(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange

  private void schroedinger2D1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_schroedinger2D1SourceChanged
    complexGridView1.setModel(schroedinger2D1);
    complexToRealFunctionAdapter1.setComplexFunction(schroedinger2D1);
  }//GEN-LAST:event_schroedinger2D1SourceChanged

  private void cutFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_cutFunction1ValueChanged
    functionView1.setModel(cutFunction1.getXVector(), cutFunction1.getYVector());
  }//GEN-LAST:event_cutFunction1ValueChanged

  private void functionView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_functionView1SourceChanged
    controlledLayeredScreen1.addView(functionView1);
  }//GEN-LAST:event_functionView1SourceChanged

  private void complexGridView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_complexGridView1SourceChanged
    layeredScreen1.addView(complexGridView1);
  }//GEN-LAST:event_complexGridView1SourceChanged

  private void complexToRealFunctionAdapter1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_complexToRealFunctionAdapter1ValueChanged
    cutFunction1.setScalarField(complexToRealFunctionAdapter1);
  }//GEN-LAST:event_complexToRealFunctionAdapter1ValueChanged

  private void radioButtonBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_radioButtonBox1ValueChanged
    complexToRealFunctionAdapter1.setConversionTypeFromInt(radioButtonBox1.getSelected());
}//GEN-LAST:event_radioButtonBox1ValueChanged

  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    double val = textSlider2.getValue();
    cutFunction1.setY(val);
    simpleFigureView1.setP1(new DVector(-8.0e-9, val));
    simpleFigureView1.setP2(new DVector(8.0e-9, val));
  }//GEN-LAST:event_textSlider2PropertyChange

  private void simpleFigureView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_simpleFigureView1SourceChanged
    layeredScreen1.addView(simpleFigureView1);
  }//GEN-LAST:event_simpleFigureView1SourceChanged

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    layeredScreen1.setViewActive(1, switchBox1.getSelected(0));
  }//GEN-LAST:event_switchBox1ValueChanged

  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.views.ComplexGridView complexGridView1;
  protected physbeans.func.ComplexToRealFunctionAdapter complexToRealFunctionAdapter1;
  protected physbeans.inout.ControlledLayeredScreen controlledLayeredScreen1;
  protected physbeans.func.CutFunction cutFunction1;
  protected physbeans.views.FunctionView functionView1;
  protected physbeans.phys.GaussianGridInitializer gaussianGridInitializer1;
  protected physbeans.phys.Harmonic2DPotential harmonic2DPotential1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.views.JetColorTable jetColorTable1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.inout.RadioButtonBox radioButtonBox1;
  protected physbeans.phys.Schroedinger2D schroedinger2D1;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.VectorSlider vectorSlider1;
  protected physbeans.inout.VectorSlider vectorSlider2;
  // End of variables declaration//GEN-END:variables
}
