package physapps.quantummechanics;

import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class QMSingleSlit extends PhysBeansApplet {

  static public void main(String[] args) {
    startApp(new QMSingleSlit(), 580, 580);
  }

  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    schroedinger2DPML1 = new physbeans.phys.Schroedinger2DPML();
    wall2DPotential1 = new physbeans.phys.Wall2DPotential();
    gaussianGridInitializer1 = new physbeans.phys.GaussianGridInitializer();
    jetColorTable1 = new physbeans.views.JetColorTable();
    complexGridView1 = new physbeans.views.ComplexGridView();
    gratingWall1 = new physbeans.phys.GratingWall();
    transparentColorTable1 = new physbeans.views.TransparentColorTable();
    gridView1 = new physbeans.views.GridView();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    complexToRealFunctionAdapter1 = new physbeans.func.ComplexToRealFunctionAdapter();
    cutFunction1 = new physbeans.func.CutFunction();
    functionView1 = new physbeans.views.FunctionView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    controlledLayeredScreen1 = new physbeans.inout.ControlledLayeredScreen();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    vectorSliderX0 = new physbeans.inout.VectorSlider();
    vectorSliderV0 = new physbeans.inout.VectorSlider();
    textSliderS = new physbeans.inout.TextSlider();
    textSliderD = new physbeans.inout.TextSlider();
    radioButtonBox1 = new physbeans.inout.RadioButtonBox();
    switchBox1 = new physbeans.inout.SwitchBox();
    textSliderY = new physbeans.inout.TextSlider();

    schroedinger2DPML1.setXMax(8.0E-9);
    schroedinger2DPML1.setXMin(-8.0E-9);
    schroedinger2DPML1.setYMax(8.0E-9);
    schroedinger2DPML1.setYMin(-8.0E-9);
    schroedinger2DPML1.setInitFunction(gaussianGridInitializer1);
    schroedinger2DPML1.setPotential(wall2DPotential1);
    schroedinger2DPML1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        schroedinger2DPML1SourceChanged(evt);
      }
    });

    wall2DPotential1.setWall(gratingWall1);
    wall2DPotential1.setWallValue(5.0E-19);

    complexGridView1.setColors(jetColorTable1);
    complexGridView1.setDepth(60);
    complexGridView1.setMaxVal(2.0E8);
    complexGridView1.setMinVal(-2.0E8);
    complexGridView1.setType(ComplexToRealEnum.ABS2);
    complexGridView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        complexGridView1SourceChanged(evt);
      }
    });

    gratingWall1.setNumberOfSlits(1);
    gratingWall1.setPosition(0.0);
    gratingWall1.setThickness(2);
    gratingWall1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        gratingWall1SourceChanged(evt);
      }
    });

    gridView1.setColors(transparentColorTable1);
    gridView1.setMinVal(0.0);
    gridView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        gridView1SourceChanged(evt);
      }
    });

    simpleFigureView1.setDepth(40);
    simpleFigureView1.setFigureType(0);
    simpleFigureView1.setP1(DVector.valueOf("[-8.0E-9,0.0]"));
    simpleFigureView1.setP2(DVector.valueOf("[8.0E-9,1.0]"));
    simpleFigureView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        simpleFigureView1SourceChanged(evt);
      }
    });

    complexToRealFunctionAdapter1.setYMax(3.0E8);
    complexToRealFunctionAdapter1.setYMin(-3.0E8);
    complexToRealFunctionAdapter1.setConversionType(ComplexToRealEnum.ABS);
    complexToRealFunctionAdapter1.setCutoff(1.0E7);
    complexToRealFunctionAdapter1.setScreen(controlledLayeredScreen1);
    complexToRealFunctionAdapter1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        complexToRealFunctionAdapter1ValueChanged(evt);
      }
    });

    cutFunction1.setXMax(8.0E-9);
    cutFunction1.setXMin(-8.0E-9);
    cutFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        cutFunction1ValueChanged(evt);
      }
    });

    functionView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        functionView1SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    objectPanel.setPreferredSize(new java.awt.Dimension(106, 300));
    objectPanel.setLayout(new java.awt.BorderLayout());

    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(8.0E-9);
    layeredScreen1.setMinX(-8.0E-9);
    layeredScreen1.setViewActive(new boolean[] {true, true, false});
    objectPanel.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel);

    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    outputPanel.setPreferredSize(new java.awt.Dimension(316, 200));
    outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.LINE_AXIS));

    controlledLayeredScreen1.setBordered(true);
    controlledLayeredScreen1.setMaxX(8.0E-9);
    controlledLayeredScreen1.setMinX(-8.0E-9);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.quantummechanics.QMSingleSlit", currentLocale); // NOI18N
    controlledLayeredScreen1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    controlledLayeredScreen1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    outputPanel.add(controlledLayeredScreen1);

    jPanel2.add(outputPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(30L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    inputPanel.add(timer1);

    vectorSliderX0.setColumns(7);
    vectorSliderX0.setCount(2);
    vectorSliderX0.setDescription("x0 =");
    vectorSliderX0.setInitialValues(DVector.valueOf("[-4.0E-9,0.0]"));
    vectorSliderX0.setMaximum(4.0E-9);
    vectorSliderX0.setMinimum(-4.0E-9);
    vectorSliderX0.setUnit("m");
    vectorSliderX0.setVertical(false);
    vectorSliderX0.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderX0PropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderX0);

    vectorSliderV0.setColumns(6);
    vectorSliderV0.setCount(2);
    vectorSliderV0.setDescription("v0 =");
    vectorSliderV0.setInitialValues(DVector.valueOf("[300000.0,0.0]"));
    vectorSliderV0.setMaximum(700000.0);
    vectorSliderV0.setMinimum(-700000.0);
    vectorSliderV0.setUnit("m/s");
    vectorSliderV0.setVertical(false);
    vectorSliderV0.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderV0PropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderV0);

    textSliderS.setColumns(6);
    textSliderS.setDescription("s =");
    textSliderS.setModel(new BoundedRealModel(1.0E-10,2.0E-9,4.0E-9));
    textSliderS.setUnit("m");
    textSliderS.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderSPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderS);

    textSliderD.setColumns(6);
    textSliderD.setDescription("d =");
    textSliderD.setModel(new BoundedRealModel(1.0E-10,3.0E-9,1.6E-8));
    textSliderD.setUnit("m");
    textSliderD.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderDPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderD);

    radioButtonBox1.setBoxLabel( new String[] {
      bundle.getString("real"), bundle.getString("imag"), bundle.getString("abs"),
      bundle.getString("abs2"), bundle.getString("phase")
    }
  );
  radioButtonBox1.setSelected(2);
  radioButtonBox1.setTitle(bundle.getString("Display")); // NOI18N
  radioButtonBox1.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      radioButtonBox1ValueChanged(evt);
    }
  });
  inputPanel.add(radioButtonBox1);

  switchBox1.setBoxLabel( new String[] {bundle.getString("s1")}
  );
  switchBox1.setSelected(new boolean[] {false});
  switchBox1.setTitle("");
  switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      switchBox1ValueChanged(evt);
    }
  });
  inputPanel.add(switchBox1);

  textSliderY.setColumns(6);
  textSliderY.setDescription("y =");
  textSliderY.setModel(new BoundedRealModel(-8.0E-9,0.0,8.0E-9));
  textSliderY.setUnit("m");
  textSliderY.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSliderYPropertyChange(evt);
    }
  });
  inputPanel.add(textSliderY);

  jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

  getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    schroedinger2DPML1.nextStep();
  }//GEN-LAST:event_timer1NextStep

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    schroedinger2DPML1.restart();
  }//GEN-LAST:event_timer1Restart

  private void vectorSliderX0PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderX0PropertyChange
    gaussianGridInitializer1.setX0(vectorSliderX0.getValue());
  }//GEN-LAST:event_vectorSliderX0PropertyChange

  private void vectorSliderV0PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderV0PropertyChange
    gaussianGridInitializer1.setV0(vectorSliderV0.getValue());
  }//GEN-LAST:event_vectorSliderV0PropertyChange

  private void textSliderSPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderSPropertyChange
    gaussianGridInitializer1.setWidth(textSliderS.getValue());
  }//GEN-LAST:event_textSliderSPropertyChange

  private void cutFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_cutFunction1ValueChanged
    functionView1.setModel(cutFunction1.getXVector(), cutFunction1.getYVector());
  }//GEN-LAST:event_cutFunction1ValueChanged

  private void functionView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_functionView1SourceChanged
    controlledLayeredScreen1.addView(functionView1);
  }//GEN-LAST:event_functionView1SourceChanged

  private void complexGridView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_complexGridView1SourceChanged
    layeredScreen1.addView(complexGridView1);
  }//GEN-LAST:event_complexGridView1SourceChanged

  private void complexToRealFunctionAdapter1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_complexToRealFunctionAdapter1ValueChanged
    cutFunction1.setScalarField(complexToRealFunctionAdapter1);
  }//GEN-LAST:event_complexToRealFunctionAdapter1ValueChanged

  private void radioButtonBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_radioButtonBox1ValueChanged
    complexToRealFunctionAdapter1.setConversionTypeFromInt(radioButtonBox1.getSelected());
}//GEN-LAST:event_radioButtonBox1ValueChanged

  private void textSliderYPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderYPropertyChange
    double val = textSliderY.getValue();
    cutFunction1.setY(val);
    simpleFigureView1.setP1(new DVector(-8.0e-9, val));
    simpleFigureView1.setP2(new DVector(8.0e-9, val));
  }//GEN-LAST:event_textSliderYPropertyChange

  private void simpleFigureView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_simpleFigureView1SourceChanged
    layeredScreen1.addView(simpleFigureView1);
  }//GEN-LAST:event_simpleFigureView1SourceChanged

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    layeredScreen1.setViewActive(2, switchBox1.getSelected(0));
  }//GEN-LAST:event_switchBox1ValueChanged

  private void gratingWall1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_gratingWall1SourceChanged
    gridView1.setModel(gratingWall1);
  }//GEN-LAST:event_gratingWall1SourceChanged

  private void gridView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_gridView1SourceChanged
    layeredScreen1.addView(gridView1);
  }//GEN-LAST:event_gridView1SourceChanged

  private void textSliderDPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderDPropertyChange
    gratingWall1.setSlitWidth(textSliderD.getValue());
  }//GEN-LAST:event_textSliderDPropertyChange

  private void schroedinger2DPML1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_schroedinger2DPML1SourceChanged
    complexGridView1.setModel(schroedinger2DPML1);
    complexToRealFunctionAdapter1.setComplexFunction(schroedinger2DPML1);
  }//GEN-LAST:event_schroedinger2DPML1SourceChanged

  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.views.ComplexGridView complexGridView1;
  protected physbeans.func.ComplexToRealFunctionAdapter complexToRealFunctionAdapter1;
  protected physbeans.inout.ControlledLayeredScreen controlledLayeredScreen1;
  protected physbeans.func.CutFunction cutFunction1;
  protected physbeans.views.FunctionView functionView1;
  protected physbeans.phys.GaussianGridInitializer gaussianGridInitializer1;
  protected physbeans.phys.GratingWall gratingWall1;
  protected physbeans.views.GridView gridView1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.views.JetColorTable jetColorTable1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.inout.RadioButtonBox radioButtonBox1;
  protected physbeans.phys.Schroedinger2DPML schroedinger2DPML1;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSliderD;
  protected physbeans.inout.TextSlider textSliderS;
  protected physbeans.inout.TextSlider textSliderY;
  protected physbeans.inout.Timer timer1;
  protected physbeans.views.TransparentColorTable transparentColorTable1;
  protected physbeans.inout.VectorSlider vectorSliderV0;
  protected physbeans.inout.VectorSlider vectorSliderX0;
  protected physbeans.phys.Wall2DPotential wall2DPotential1;
  // End of variables declaration//GEN-END:variables
}
