package physapps.waves;
import physbeans.inout.*;
import physbeans.model.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class MovingSourceDoppler extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new MovingSourceDoppler(), 530, 500);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    rippleTank1 = new physbeans.phys.RippleTank();
    pointWaveSource1 = new physbeans.phys.PointWaveSource();
    gridView1 = new physbeans.views.GridView();
    cutFunction1 = new physbeans.func.CutFunction();
    functionView1 = new physbeans.views.FunctionView();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    controlledLayeredScreen1 = new physbeans.inout.ControlledLayeredScreen();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();
    textSlider3 = new physbeans.inout.TextSlider();

    rippleTank1.setGridSizeX(190);
    rippleTank1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        rippleTank1SourceChanged(evt);
      }
    });

    pointWaveSource1.setInitialPosition(DVector.valueOf("[-0.5,0.0]"));
    pointWaveSource1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        pointWaveSource1SourceChanged(evt);
      }
    });

    gridView1.setDepth(60);
    gridView1.setInfiniteScale(true);
    gridView1.setScale(0.1);
    gridView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        gridView1SourceChanged(evt);
      }
    });

    cutFunction1.setNPoints(150);
    cutFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        cutFunction1ValueChanged(evt);
      }
    });

    functionView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        functionView1SourceChanged(evt);
      }
    });

    simpleFigureView1.setFigureType(0);
    simpleFigureView1.setP1(DVector.valueOf("[-1.0,0.0]"));
    simpleFigureView1.setP2(DVector.valueOf("[1.0,0.0]"));
    simpleFigureView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        simpleFigureView1SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setPreferredSize(new java.awt.Dimension(290, 300));
    jPanel2.setLayout(new java.awt.BorderLayout());

    objectPanel1.setPreferredSize(new java.awt.Dimension(106, 300));

    layeredScreen1.setViewActive(new boolean[]{true,true});
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel1, java.awt.BorderLayout.CENTER);

    outputPanel1.setPreferredSize(new java.awt.Dimension(4, 195));

    controlledLayeredScreen1.setBordered(true);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.waves.MovingSourceDoppler", currentLocale); // NOI18N
    controlledLayeredScreen1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    controlledLayeredScreen1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    outputPanel1.add(controlledLayeredScreen1);

    jPanel2.add(outputPanel1, java.awt.BorderLayout.SOUTH);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));

    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    inputPanel1.add(timer1);

    textSlider1.setDescription("f =");
    textSlider1.setModel(new BoundedRealModel(2.0,5.0,7.0));
    textSlider1.setUnit("Hz");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider1);

    textSlider2.setDescription("A = ");
    textSlider2.setModel(new BoundedRealModel(0.0,1.0,3.0));
    textSlider2.setUnit("m");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider2);

    textSlider4.setDescription("v =");
    textSlider4.setModel(new BoundedRealModel(-2.0,0.5,2.0));
    textSlider4.setUnit("m/s");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider4);

    switchBox1.setBoxLabel( new String[] {
      java.util.ResourceBundle.getBundle("physapps.waves.MovingSourceDoppler", currentLocale).getString("s1")
    }
  );
  switchBox1.setSelected(new boolean[]{true});
  switchBox1.setTitle("");
  switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      switchBox1ValueChanged(evt);
    }
  });
  inputPanel1.add(switchBox1);

  textSlider3.setDescription("y =");
  textSlider3.setModel(new BoundedRealModel(-0.99,0.0,0.99));
  textSlider3.setUnit("m");
  textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSlider3PropertyChange(evt);
    }
  });
  inputPanel1.add(textSlider3);

  jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);

  getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void pointWaveSource1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pointWaveSource1SourceChanged
    rippleTank1.addSource(pointWaveSource1);
  }//GEN-LAST:event_pointWaveSource1SourceChanged

  private void simpleFigureView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_simpleFigureView1SourceChanged
    layeredScreen1.addView(simpleFigureView1);
  }//GEN-LAST:event_simpleFigureView1SourceChanged

  private void gridView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_gridView1SourceChanged
    layeredScreen1.addView(gridView1);
  }//GEN-LAST:event_gridView1SourceChanged

  private void functionView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_functionView1SourceChanged
    controlledLayeredScreen1.addView(functionView1);
  }//GEN-LAST:event_functionView1SourceChanged
  
  private void cutFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_cutFunction1ValueChanged
    functionView1.setModel(cutFunction1.getXVector(), cutFunction1.getYVector());
  }//GEN-LAST:event_cutFunction1ValueChanged
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    pointWaveSource1.setVelocityX(textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    layeredScreen1.setViewActive(1, switchBox1.getSelected(0));
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    double val = textSlider3.getValue();
    cutFunction1.setY(val);
    simpleFigureView1.setP1(new DVector(-1.0, val));
    simpleFigureView1.setP2(new DVector(1.0, val));
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    pointWaveSource1.setAmplitude(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    pointWaveSource1.setFrequency(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    rippleTank1.restart();
    pointWaveSource1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    rippleTank1.nextStep();
  }//GEN-LAST:event_timer1NextStep
  
  private void rippleTank1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_rippleTank1SourceChanged
    gridView1.setModel(rippleTank1);
    cutFunction1.setScalarField(rippleTank1);
  }//GEN-LAST:event_rippleTank1SourceChanged
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.ControlledLayeredScreen controlledLayeredScreen1;
  protected physbeans.func.CutFunction cutFunction1;
  protected physbeans.views.FunctionView functionView1;
  protected physbeans.views.GridView gridView1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.PointWaveSource pointWaveSource1;
  protected physbeans.phys.RippleTank rippleTank1;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.Timer timer1;
  // End of variables declaration//GEN-END:variables
  
}
